diff -pruN 5.58.2+~cs0.23.101-1/addon/display/placeholder.js 5.59.0+~cs0.23.105-1/addon/display/placeholder.js
--- 5.58.2+~cs0.23.101-1/addon/display/placeholder.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/addon/display/placeholder.js	2020-12-20 10:48:25.000000000 +0000
@@ -50,11 +50,12 @@
 
   function onComposition(cm) {
     setTimeout(function() {
-      var empty = false, input = cm.getInputField()
-      if (input.nodeName == "TEXTAREA")
-        empty = !input.value
-      else if (cm.lineCount() == 1)
-        empty = !/[^\u200b]/.test(input.querySelector(".CodeMirror-line").textContent)
+      var empty = false
+      if (cm.lineCount() == 1) {
+        var input = cm.getInputField()
+        empty = input.nodeName == "TEXTAREA" ? !cm.getLine(0).length
+          : !/[^\u200b]/.test(input.querySelector(".CodeMirror-line").textContent)
+      }
       if (empty) setPlaceholder(cm)
       else clearPlaceholder(cm)
     }, 20)
diff -pruN 5.58.2+~cs0.23.101-1/addon/edit/closetag.js 5.59.0+~cs0.23.105-1/addon/edit/closetag.js
--- 5.58.2+~cs0.23.101-1/addon/edit/closetag.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/addon/edit/closetag.js	2020-12-20 10:48:25.000000000 +0000
@@ -128,9 +128,10 @@
         replacement = head + "style";
       } else {
         var context = inner.mode.xmlCurrentContext && inner.mode.xmlCurrentContext(state)
-        if (!context || (context.length && closingTagExists(cm, context, context[context.length - 1], pos)))
+        var top = context.length ? context[context.length - 1] : ""
+        if (!context || (context.length && closingTagExists(cm, context, top, pos)))
           return CodeMirror.Pass;
-        replacement = head + context[context.length - 1]
+        replacement = head + top
       }
       if (cm.getLine(pos.line).charAt(tok.end) != ">") replacement += ">";
       replacements[i] = replacement;
diff -pruN 5.58.2+~cs0.23.101-1/addon/edit/matchbrackets.js 5.59.0+~cs0.23.105-1/addon/edit/matchbrackets.js
--- 5.58.2+~cs0.23.101-1/addon/edit/matchbrackets.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/addon/edit/matchbrackets.js	2020-12-20 10:48:25.000000000 +0000
@@ -117,25 +117,25 @@
     });
   }
 
-  CodeMirror.defineOption("matchBrackets", false, function(cm, val, old) {
-    function clear(cm) {
-      if (cm.state.matchBrackets && cm.state.matchBrackets.currentlyHighlighted) {
-        cm.state.matchBrackets.currentlyHighlighted();
-        cm.state.matchBrackets.currentlyHighlighted = null;
-      }
+  function clearHighlighted(cm) {
+    if (cm.state.matchBrackets && cm.state.matchBrackets.currentlyHighlighted) {
+      cm.state.matchBrackets.currentlyHighlighted();
+      cm.state.matchBrackets.currentlyHighlighted = null;
     }
+  }
 
+  CodeMirror.defineOption("matchBrackets", false, function(cm, val, old) {
     if (old && old != CodeMirror.Init) {
       cm.off("cursorActivity", doMatchBrackets);
       cm.off("focus", doMatchBrackets)
-      cm.off("blur", clear)
-      clear(cm);
+      cm.off("blur", clearHighlighted)
+      clearHighlighted(cm);
     }
     if (val) {
       cm.state.matchBrackets = typeof val == "object" ? val : {};
       cm.on("cursorActivity", doMatchBrackets);
       cm.on("focus", doMatchBrackets)
-      cm.on("blur", clear)
+      cm.on("blur", clearHighlighted)
     }
   });
 
diff -pruN 5.58.2+~cs0.23.101-1/addon/hint/html-hint.js 5.59.0+~cs0.23.105-1/addon/hint/html-hint.js
--- 5.58.2+~cs0.23.101-1/addon/hint/html-hint.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/addon/hint/html-hint.js	2020-12-20 10:48:25.000000000 +0000
@@ -98,6 +98,7 @@
     dfn: s,
     dir: s,
     div: s,
+    dialog: { attrs: { open: null } },
     dl: s,
     dt: s,
     em: s,
diff -pruN 5.58.2+~cs0.23.101-1/addon/hint/show-hint.js 5.59.0+~cs0.23.105-1/addon/hint/show-hint.js
--- 5.58.2+~cs0.23.101-1/addon/hint/show-hint.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/addon/hint/show-hint.js	2020-12-20 10:48:25.000000000 +0000
@@ -1,6 +1,8 @@
 // CodeMirror, copyright (c) by Marijn Haverbeke and others
 // Distributed under an MIT license: https://codemirror.net/LICENSE
 
+// declare global: DOMRect
+
 (function(mod) {
   if (typeof exports == "object" && typeof module == "object") // CommonJS
     mod(require("../../lib/codemirror"));
@@ -94,8 +96,10 @@
                                completion.to || data.to, "complete");
         CodeMirror.signal(data, "pick", completion);
         self.cm.scrollIntoView();
-      })
-      this.close();
+      });
+      if (this.options.closeOnPick) {
+        this.close();
+      }
     },
 
     cursorActivity: function() {
@@ -113,7 +117,9 @@
       if (pos.line != this.startPos.line || line.length - pos.ch != this.startLen - this.startPos.ch ||
           pos.ch < identStart.ch || this.cm.somethingSelected() ||
           (!pos.ch || this.options.closeCharacters.test(line.charAt(pos.ch - 1)))) {
-        this.close();
+        if (this.options.closeOnCursorActivity) {
+          this.close();
+        }
       } else {
         var self = this;
         this.debounce = requestAnimationFrame(function() {self.update();});
@@ -259,10 +265,15 @@
     var winW = parentWindow.innerWidth || Math.max(ownerDocument.body.offsetWidth, ownerDocument.documentElement.offsetWidth);
     var winH = parentWindow.innerHeight || Math.max(ownerDocument.body.offsetHeight, ownerDocument.documentElement.offsetHeight);
     container.appendChild(hints);
-    var box = hints.getBoundingClientRect(), overlapY = box.bottom - winH;
-    var scrolls = hints.scrollHeight > hints.clientHeight + 1
-    var startScroll = cm.getScrollInfo();
 
+    var box = completion.options.moveOnOverlap ? hints.getBoundingClientRect() : new DOMRect();
+    var scrolls = completion.options.paddingForScrollbar ? hints.scrollHeight > hints.clientHeight + 1 : false;
+
+    // Compute in the timeout to avoid reflow on init
+    var startScroll;
+    setTimeout(function() { startScroll = cm.getScrollInfo(); });
+
+    var overlapY = box.bottom - winH;
     if (overlapY > 0) {
       var height = box.bottom - box.top, curTop = pos.top - (pos.bottom - box.top);
       if (curTop - height > 0) { // Fits above cursor
@@ -332,7 +343,12 @@
     CodeMirror.on(hints, "mousedown", function() {
       setTimeout(function(){cm.focus();}, 20);
     });
-    this.scrollToActive()
+
+    // The first hint doesn't need to be scrolled to on init
+    var selectedHintRange = this.getSelectedHintRange();
+    if (selectedHintRange.from !== 0 || selectedHintRange.to !== 0) {
+      this.scrollToActive();
+    }
 
     CodeMirror.signal(data, "select", completions[this.selectedHint], hints.childNodes[this.selectedHint]);
     return true;
@@ -379,9 +395,9 @@
     },
 
     scrollToActive: function() {
-      var margin = this.completion.options.scrollMargin || 0;
-      var node1 = this.hints.childNodes[Math.max(0, this.selectedHint - margin)];
-      var node2 = this.hints.childNodes[Math.min(this.data.list.length - 1, this.selectedHint + margin)];
+      var selectedHintRange = this.getSelectedHintRange();
+      var node1 = this.hints.childNodes[selectedHintRange.from];
+      var node2 = this.hints.childNodes[selectedHintRange.to];
       var firstNode = this.hints.firstChild;
       if (node1.offsetTop < this.hints.scrollTop)
         this.hints.scrollTop = node1.offsetTop - firstNode.offsetTop;
@@ -391,6 +407,14 @@
 
     screenAmount: function() {
       return Math.floor(this.hints.clientHeight / this.hints.firstChild.offsetHeight) || 1;
+    },
+
+    getSelectedHintRange: function() {
+      var margin = this.completion.options.scrollMargin || 0;
+      return {
+        from: Math.max(0, this.selectedHint - margin),
+        to: Math.min(this.data.list.length - 1, this.selectedHint + margin),
+      };
     }
   };
 
@@ -468,11 +492,15 @@
     completeSingle: true,
     alignWithWord: true,
     closeCharacters: /[\s()\[\]{};:>,]/,
+    closeOnCursorActivity: true,
+    closeOnPick: true,
     closeOnUnfocus: true,
     completeOnSingleClick: true,
     container: null,
     customKeys: null,
-    extraKeys: null
+    extraKeys: null,
+    paddingForScrollbar: true,
+    moveOnOverlap: true,
   };
 
   CodeMirror.defineOption("hintOptions", null);
diff -pruN 5.58.2+~cs0.23.101-1/addon/hint/xml-hint.js 5.59.0+~cs0.23.105-1/addon/hint/xml-hint.js
--- 5.58.2+~cs0.23.101-1/addon/hint/xml-hint.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/addon/hint/xml-hint.js	2020-12-20 10:48:25.000000000 +0000
@@ -101,12 +101,12 @@
           }
           replaceToken = true;
         }
-        function returnHintsFromAtValues(atValues) {
+        var returnHintsFromAtValues = function(atValues) {
           if (atValues)
             for (var i = 0; i < atValues.length; ++i) if (!prefix || matches(atValues[i], prefix, matchInMiddle))
               result.push(quote + atValues[i] + quote);
           return returnHints();
-        }
+        };
         if (atValues && atValues.then) return atValues.then(returnHintsFromAtValues);
         return returnHintsFromAtValues(atValues);
       } else { // An attribute name
diff -pruN 5.58.2+~cs0.23.101-1/addon/lint/javascript-lint.js 5.59.0+~cs0.23.105-1/addon/lint/javascript-lint.js
--- 5.58.2+~cs0.23.101-1/addon/lint/javascript-lint.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/addon/lint/javascript-lint.js	2020-12-20 10:48:25.000000000 +0000
@@ -1,6 +1,8 @@
 // CodeMirror, copyright (c) by Marijn Haverbeke and others
 // Distributed under an MIT license: https://codemirror.net/LICENSE
 
+// Depends on jshint.js from https://github.com/jshint/jshint
+
 (function(mod) {
   if (typeof exports == "object" && typeof module == "object") // CommonJS
     mod(require("../../lib/codemirror"));
diff -pruN 5.58.2+~cs0.23.101-1/addon/lint/lint.js 5.59.0+~cs0.23.105-1/addon/lint/lint.js
--- 5.58.2+~cs0.23.101-1/addon/lint/lint.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/addon/lint/lint.js	2020-12-20 10:48:25.000000000 +0000
@@ -170,6 +170,10 @@
       var anns = annotations[line];
       if (!anns) continue;
 
+      // filter out duplicate messages
+      var message = [];
+      anns = anns.filter(function(item) { return message.indexOf(item.message) > -1 ? false : message.push(item.message) });
+
       var maxSeverity = null;
       var tipLabel = state.hasGutter && document.createDocumentFragment();
 
@@ -187,9 +191,9 @@
           __annotation: ann
         }));
       }
-
+      // use original annotations[line] to show multiple messages
       if (state.hasGutter)
-        cm.setGutterMarker(line, GUTTER_ID, makeMarker(cm, tipLabel, maxSeverity, anns.length > 1,
+        cm.setGutterMarker(line, GUTTER_ID, makeMarker(cm, tipLabel, maxSeverity, annotations[line].length > 1,
                                                        state.options.tooltips));
     }
     if (options.onUpdateLinting) options.onUpdateLinting(annotationsNotSorted, annotations, cm);
diff -pruN 5.58.2+~cs0.23.101-1/addon/search/jump-to-line.js 5.59.0+~cs0.23.105-1/addon/search/jump-to-line.js
--- 5.58.2+~cs0.23.101-1/addon/search/jump-to-line.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/addon/search/jump-to-line.js	2020-12-20 10:48:25.000000000 +0000
@@ -13,8 +13,11 @@
 })(function(CodeMirror) {
   "use strict";
 
+  // default search panel location
+  CodeMirror.defineOption("search", {bottom: false});
+
   function dialog(cm, text, shortText, deflt, f) {
-    if (cm.openDialog) cm.openDialog(text, f, {value: deflt, selectValueOnOpen: true});
+    if (cm.openDialog) cm.openDialog(text, f, {value: deflt, selectValueOnOpen: true, bottom: cm.options.search.bottom});
     else f(prompt(shortText, deflt));
   }
 
diff -pruN 5.58.2+~cs0.23.101-1/addon/search/search.js 5.59.0+~cs0.23.105-1/addon/search/search.js
--- 5.58.2+~cs0.23.101-1/addon/search/search.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/addon/search/search.js	2020-12-20 10:48:25.000000000 +0000
@@ -19,6 +19,9 @@
 })(function(CodeMirror) {
   "use strict";
 
+  // default search panel location
+  CodeMirror.defineOption("search", {bottom: false});
+
   function searchOverlay(query, caseInsensitive) {
     if (typeof query == "string")
       query = new RegExp(query.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&"), caseInsensitive ? "gi" : "g");
@@ -63,12 +66,13 @@
       selectValueOnOpen: true,
       closeOnEnter: false,
       onClose: function() { clearSearch(cm); },
-      onKeyDown: onKeyDown
+      onKeyDown: onKeyDown,
+      bottom: cm.options.search.bottom
     });
   }
 
   function dialog(cm, text, shortText, deflt, f) {
-    if (cm.openDialog) cm.openDialog(text, f, {value: deflt, selectValueOnOpen: true});
+    if (cm.openDialog) cm.openDialog(text, f, {value: deflt, selectValueOnOpen: true, bottom: cm.options.search.bottom});
     else f(prompt(shortText, deflt));
   }
 
diff -pruN 5.58.2+~cs0.23.101-1/addon/wrap/hardwrap.js 5.59.0+~cs0.23.105-1/addon/wrap/hardwrap.js
--- 5.58.2+~cs0.23.101-1/addon/wrap/hardwrap.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/addon/wrap/hardwrap.js	2020-12-20 10:48:25.000000000 +0000
@@ -35,7 +35,7 @@
     for (; at > 0; --at)
       if (wrapOn.test(text.slice(at - 1, at + 1))) break;
 
-    if (at == 0 && !forceBreak) {
+    if (!forceBreak && at <= text.match(/^[ \t]*/)[0].length) {
       // didn't find a break point before column, in non-forceBreak mode try to
       // find one after 'column'.
       for (at = column + 1; at < text.length - 1; ++at) {
@@ -91,7 +91,8 @@
       }
       while (curLine.length > column) {
         var bp = findBreakPoint(curLine, column, wrapOn, killTrailing, forceBreak);
-        if (bp.from != bp.to || forceBreak) {
+        if (bp.from != bp.to ||
+            forceBreak && leadingSpace !== curLine.slice(0, bp.to)) {
           changes.push({text: ["", leadingSpace],
                         from: Pos(curNo, bp.from),
                         to: Pos(curNo, bp.to)});
diff -pruN 5.58.2+~cs0.23.101-1/AUTHORS 5.59.0+~cs0.23.105-1/AUTHORS
--- 5.58.2+~cs0.23.101-1/AUTHORS	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/AUTHORS	2020-12-20 10:48:25.000000000 +0000
@@ -244,6 +244,7 @@ edoroshenko
 edsharp
 ekhaled
 Elisée
+Elmar Peise
 elpnt
 Emmanuel Schanzer
 Enam Mijbah Noor
@@ -251,6 +252,7 @@ Eric Allam
 Eric Bogard
 Erik Demaine
 Erik Welander
+erosman
 eustas
 Evan Minsk
 Fabien Dubosson
@@ -326,6 +328,7 @@ Heanes
 Hector Oswaldo Caballero
 Hein Htat
 Hélio
+Hendrik Erz
 Hendrik Wallbaum
 Henrik Haugbølle
 Herculano Campos
@@ -353,6 +356,7 @@ Ilya Zverev
 Ingo Richter
 Intervue
 Irakli Gozalishvili
+iteriani
 Ivan Kurnosov
 Ivoah
 Jack Douglas
@@ -360,6 +364,7 @@ Jacob Lee
 Jaimin
 Jake Peyser
 Jakob Miland
+Jakub T. Jankiewicz
 Jakub Vrana
 Jakub Vrána
 James Campos
@@ -463,6 +468,7 @@ Kevin Muret
 Kevin Sawicki
 Kevin Ushey
 Kier Darby
+Kim-Anh Tran
 Klaus Silveira
 Koh Zi Han, Cliff
 komakino
@@ -517,6 +523,7 @@ Manuel Rego Casasnovas
 Marat Dreizin
 Marcel Gerber
 Marcelo Camargo
+Marc Espín
 Marco Aurélio
 Marco Munizaga
 Marcus Bointon
@@ -543,6 +550,7 @@ Mason Malone
 Mateusz Paprocki
 Mathias Bynens
 mats cronqvist
+Matt Diehl
 Matt Gaide
 Matthew Bauer
 Matthew Beale
@@ -600,6 +608,7 @@ Miraculix87
 misfo
 mkaminsky11
 mloginov
+mlsad3
 Moritz Schubotz (physikerwelt)
 Moritz Schwörer
 Moshe Wajnberg
@@ -610,6 +619,7 @@ Mu-An ✌️ Chiou
 Mu-An Chiou
 mzabuawala
 Narciso Jaramillo
+nathanlesage
 Nathan Williams
 ndr
 Neil Anderson
@@ -681,12 +691,14 @@ Peter Flynn
 peterkroon
 Peter Kroon
 Peter László
+Phil DeJarnett
 Philipp A
 Philipp Markovics
 Philip Stadermann
 Pi Delport
 Pierre Gerold
 Pieter Ouwerkerk
+Piyush
 Pontus Melke
 prasanthj
 Prasanth J
@@ -694,6 +706,7 @@ Prayag Verma
 prendota
 Prendota
 Qiang Li
+quiddity-wp
 Radek Piórkowski
 Rahul
 Rahul Anand
@@ -754,6 +767,7 @@ Scott Aikin
 Scott Feeney
 Scott Goodhew
 Seb35
+Sebastian Ślepowroński
 Sebastian Wilzbach
 Sebastian Zaha
 Seren D
@@ -774,6 +788,7 @@ Siamak Mokhtari
 Siddhartha Gunti
 silverwind
 Simon Edwards
+Simon Huber
 sinkuu
 snasa
 soliton4
diff -pruN 5.58.2+~cs0.23.101-1/CHANGELOG.md 5.59.0+~cs0.23.105-1/CHANGELOG.md
--- 5.58.2+~cs0.23.101-1/CHANGELOG.md	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/CHANGELOG.md	2020-12-20 10:48:25.000000000 +0000
@@ -1,3 +1,33 @@
+## 5.59.0 (2020-12-20)
+
+### Bug fixes
+
+Fix platform detection on recent iPadOS.
+
+[lint addon](https://codemirror.net/doc/manual.html#addon_lint): Don't show duplicate messages for a given line.
+
+[clojure mode](https://codemirror.net/mode/clojure/index.html): Fix regexp that matched in exponential time for some inputs.
+
+[hardwrap addon](https://codemirror.net/doc/manual.html#addon_hardwrap): Improve handling of words that are longer than the line length.
+
+[matchbrackets addon](https://codemirror.net/doc/manual.html#addon_matchbrackets): Fix leaked event handler on disabling the addon.
+
+### New features
+
+[search addon](https://codemirror.net/demo/search/): Make it possible to configure the search addon to show the dialog at the bottom of the editor.
+
+## 5.58.3 (2020-11-19)
+
+### Bug fixes
+
+Suppress quick-firing of blur-focus events when dragging and clicking on Internet Explorer.
+
+Fix the `insertAt` option to `addLineWidget` to actually allow the widget to be placed after all widgets for the line.
+
+[soy mode](https://codemirror.net/mode/soy/): Support `@Attribute` and element composition.
+
+[shell mode](https://codemirror.net/mode/shell/): Support heredoc quoting.
+
 ## 5.58.2 (2020-10-23)
 
 ### Bug fixes
diff -pruN 5.58.2+~cs0.23.101-1/debian/changelog 5.59.0+~cs0.23.105-1/debian/changelog
--- 5.58.2+~cs0.23.101-1/debian/changelog	2020-11-07 20:46:07.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/debian/changelog	2020-12-26 20:02:43.000000000 +0000
@@ -1,3 +1,10 @@
+codemirror-js (5.59.0+~cs0.23.105-1) unstable; urgency=medium
+
+  * New upstream version 5.59.0+~cs0.23.105
+  * Add Provides for node-types-codemirror and node-types-tern
+
+ -- Gordon Ball <gordon@chronitis.net>  Sat, 26 Dec 2020 20:02:43 +0000
+
 codemirror-js (5.58.2+~cs0.23.101-1) unstable; urgency=medium
 
   [ Debian Janitor ]
diff -pruN 5.58.2+~cs0.23.101-1/debian/control 5.59.0+~cs0.23.105-1/debian/control
--- 5.58.2+~cs0.23.101-1/debian/control	2020-11-07 20:46:07.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/debian/control	2020-12-26 20:02:43.000000000 +0000
@@ -18,7 +18,7 @@ Rules-Requires-Root: no
 Package: libjs-codemirror
 Architecture: all
 Depends: ${misc:Depends}
-Provides: node-codemirror (=${source:Version})
+Provides: ${nodejs:Provides}
 Recommends: javascript-common
 Suggests: libjs-requirejs
 Multi-Arch: foreign
diff -pruN 5.58.2+~cs0.23.101-1/doc/manual.html 5.59.0+~cs0.23.105-1/doc/manual.html
--- 5.58.2+~cs0.23.101-1/doc/manual.html	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/doc/manual.html	2020-12-20 10:48:25.000000000 +0000
@@ -70,7 +70,7 @@
 <section class=first id=overview>
     <h2 style="position: relative">
       User manual and reference guide
-      <span style="color: #888; font-size: 1rem; position: absolute; right: 0; bottom: 0">version 5.58.2</span>
+      <span style="color: #888; font-size: 1rem; position: absolute; right: 0; bottom: 0">version 5.59.0</span>
     </h2>
 
     <p>CodeMirror is a code-editor component that can be embedded in
@@ -512,6 +512,12 @@
       which causes the cursor to not reach all the way to the bottom
       of the line, looks better</dd>
 
+      <dt id="option_singleCursorHeightPerLine"><code><strong>singleCursorHeightPerLine</strong>: boolean</code></dt>
+      <dd>If set to <code>true</code> (the default), will keep the
+      cursor height constant for an entire line (or wrapped part of a
+      line). When <code>false</code>, the cursor's height is based on
+      the height of the adjacent reference character.</dd>
+
       <dt id="option_resetSelectionOnContextMenu"><code><strong>resetSelectionOnContextMenu</strong>: boolean</code></dt>
       <dd>Controls whether, when the context menu is opened with a
       click outside of the current selection, the cursor is moved to
@@ -2700,8 +2706,8 @@ editor.setOption("extraKeys", {
       Defines <code>editor.showHint</code>, which takes an optional
       options object, and pops up a widget that allows the user to
       select a completion. Finding hints is done with a hinting
-      functions (the <code>hint</code> option), which is a function
-      that take an editor instance and options object, and return
+      function (the <code>hint</code> option). This function
+      takes an editor instance and an options object, and returns
       a <code>{list, from, to}</code> object, where <code>list</code>
       is an array of strings or objects (the completions),
       and <code>from</code> and <code>to</code> give the start and end
@@ -2771,9 +2777,22 @@ editor.setOption("extraKeys", {
         <dt><code><strong>alignWithWord</strong>: boolean</code></dt>
         <dd>Whether the pop-up should be horizontally aligned with the
         start of the word (true, default), or with the cursor (false).</dd>
+        <dt><code><strong>closeCharacters</strong>: RegExp</code></dt>
+        <dd>A regular expression object used to match characters which
+        cause the pop up to be closed (default: <code>/[\s()\[\]{};:>,]/</code>).
+        If the user types one of these characters, the pop up will close, and
+        the <code>endCompletion</code> event is fired on the editor instance.</dd>
         <dt><code><strong>closeOnUnfocus</strong>: boolean</code></dt>
         <dd>When enabled (which is the default), the pop-up will close
         when the editor is unfocused.</dd>
+        <dt><code><strong>completeOnSingleClick</strong>: boolean</code></dt>
+        <dd>Whether a single click on a list item suffices to trigger the
+        completion (which is the default), or if the user has to use a
+        doubleclick.</dd>
+        <dt><code><strong>container</strong>: Element|null</code></dt>
+        <dd>Can be used to define a custom container for the widget. The default
+        is <code>null</code>, in which case the <code>body</code>-element will
+        be used.</dd>
         <dt><code><strong>customKeys</strong>: keymap</code></dt>
         <dd>Allows you to provide a custom key map of keys to be active
         when the pop-up is active. The handlers will be called with an
@@ -2809,6 +2828,14 @@ editor.setOption("extraKeys", {
         <dt><code><strong>"close"</strong> ()</code></dt>
         <dd>Fired when the completion is finished.</dd>
       </dl>
+      The following events will be fired on the editor instance during
+      completion:
+      <dl>
+        <dt><code><strong>"endCompletion"</strong> ()</code></dt>
+        <dd>Fired when the pop-up is being closed programmatically, e.g., when
+        the user types a character which matches the
+        <code>closeCharacters</code> option.</dd>
+      </dl>
       This addon depends on styles
       from <code>addon/hint/show-hint.css</code>. Check
       out <a href="../demo/complete.html">the demo</a> for an
diff -pruN 5.58.2+~cs0.23.101-1/doc/realworld.html 5.59.0+~cs0.23.105-1/doc/realworld.html
--- 5.58.2+~cs0.23.101-1/doc/realworld.html	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/doc/realworld.html	2020-12-20 10:48:25.000000000 +0000
@@ -96,6 +96,7 @@
       <li><a href="http://tour.golang.org">Go language tour</a></li>
       <li><a href="https://script.google.com/">Google Apps Script</a></li>
       <li><a href="http://web.uvic.ca/~siefkenj/graphit/graphit.html">Graphit</a> (function graphing)</li>
+      <li><a href="https://graviton.netlify.app/">Graviton Editor</a> (Cross-platform and modern-looking code editor)</li>
       <li><a href="https://hackmd.io">HackMD</a> (Realtime collaborative markdown notes on all platforms)</li>
       <li><a href="http://www.handcraft.com/">Handcraft</a> (HTML prototyping)</li>
       <li><a href="http://hawkee.com/">Hawkee</a></li>
@@ -128,6 +129,7 @@
       <li><a href="https://liveuml.com/">LiveUML</a> (PlantUML online editor)</li>
       <li><a href="https://github.com/TuvaLabs/markdown-delight-editor">Markdown Delight Editor</a> (extensible markdown editor polymer component)</li>
       <li><a href="http://marklighteditor.com/">Marklight editor</a> (lightweight markup editor)</li>
+      <li><a href="https://www.mediawiki.org/wiki/Extension:CodeMirror">MediaWiki extension</a> (wiki engine)</li>
       <li><a href="http://www.mergely.com/">Mergely</a> (interactive diffing)</li>
       <li><a href="http://www.iunbug.com/mihtool">MIHTool</a> (iOS web-app debugging tool)</li>
       <li><a href="http://mscgen.js.org/index.html">mscgen_js</a> (online sequence chart editor)</li>
diff -pruN 5.58.2+~cs0.23.101-1/doc/releases.html 5.59.0+~cs0.23.105-1/doc/releases.html
--- 5.58.2+~cs0.23.101-1/doc/releases.html	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/doc/releases.html	2020-12-20 10:48:25.000000000 +0000
@@ -30,6 +30,26 @@
 
   <h2>Version 5.x</h2>
 
+  <p class="rel">20-12-2020: <a href="https://codemirror.net/codemirror-5.59.0.zip">Version 5.59.0</a>:</p>
+
+  <ul class="rel-note">
+    <li>Fix platform detection on recent iPadOS.</li>
+    <li><a href="https://codemirror.net/doc/manual.html#addon_lint">lint addon</a>: Don't show duplicate messages for a given line.</li>
+    <li><a href="https://codemirror.net/mode/clojure/index.html">clojure mode</a>: Fix regexp that matched in exponential time for some inputs.</li>
+    <li><a href="https://codemirror.net/doc/manual.html#addon_hardwrap">hardwrap addon</a>: Improve handling of words that are longer than the line length.</li>
+    <li><a href="https://codemirror.net/doc/manual.html#addon_matchbrackets">matchbrackets addon</a>: Fix leaked event handler on disabling the addon.</li>
+    <li><a href="https://codemirror.net/demo/search/">search addon</a>: Make it possible to configure the search addon to show the dialog at the bottom of the editor.</li>
+  </ul>
+
+  <p class="rel">19-11-2020: <a href="https://codemirror.net/codemirror-5.58.3.zip">Version 5.58.3</a>:</p>
+
+  <ul class="rel-note">
+    <li>Suppress quick-firing of blur-focus events when dragging and clicking on Internet Explorer.</li>
+    <li>Fix the <code>insertAt</code> option to <code>addLineWidget</code> to actually allow the widget to be placed after all widgets for the line.</li>
+    <li><a href="https://codemirror.net/mode/soy/">soy mode</a>: Support <code>@Attribute</code> and element composition.</li>
+    <li><a href="https://codemirror.net/mode/shell/">shell mode</a>: Support heredoc quoting.</li>
+  </ul>
+
   <p class="rel">23-10-2020: <a href="https://codemirror.net/codemirror-5.58.2.zip">Version 5.58.2</a>:</p>
 
   <ul class="rel-note">
diff -pruN 5.58.2+~cs0.23.101-1/.github/FUNDING.yml 5.59.0+~cs0.23.105-1/.github/FUNDING.yml
--- 5.58.2+~cs0.23.101-1/.github/FUNDING.yml	1970-01-01 00:00:00.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/.github/FUNDING.yml	2020-12-20 10:48:25.000000000 +0000
@@ -0,0 +1,2 @@
+patreon: marijn
+custom: ['https://www.paypal.com/paypalme/marijnhaverbeke', 'https://marijnhaverbeke.nl/fund/']
diff -pruN 5.58.2+~cs0.23.101-1/index.html 5.59.0+~cs0.23.105-1/index.html
--- 5.58.2+~cs0.23.101-1/index.html	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/index.html	2020-12-20 10:48:25.000000000 +0000
@@ -99,7 +99,7 @@
       </div>
     </div>
     <div class=actionsleft>
-      Get the current version: <a href="https://codemirror.net/codemirror.zip">5.58.2</a>.<br>
+      Get the current version: <a href="https://codemirror.net/codemirror.zip">5.59.0</a>.<br>
       You can see the <a href="https://github.com/codemirror/codemirror" title="Github repository">code</a>,<br>
       read the <a href="doc/releases.html">release notes</a>,<br>
       or study the <a href="doc/manual.html">user manual</a>.
diff -pruN 5.58.2+~cs0.23.101-1/lib/codemirror.css 5.59.0+~cs0.23.105-1/lib/codemirror.css
--- 5.58.2+~cs0.23.101-1/lib/codemirror.css	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/lib/codemirror.css	2020-12-20 10:48:25.000000000 +0000
@@ -19,7 +19,7 @@
 }
 
 .CodeMirror-scrollbar-filler, .CodeMirror-gutter-filler {
-  background-color: white; /* The little square between H and V scrollbars */
+  background-color: transparent; /* The little square between H and V scrollbars */
 }
 
 /* GUTTER */
diff -pruN 5.58.2+~cs0.23.101-1/mode/clike/clike.js 5.59.0+~cs0.23.105-1/mode/clike/clike.js
--- 5.58.2+~cs0.23.101-1/mode/clike/clike.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/clike/clike.js	2020-12-20 10:48:25.000000000 +0000
@@ -82,15 +82,15 @@ CodeMirror.defineMode("clike", function(
       state.tokenize = tokenString(ch);
       return state.tokenize(stream, state);
     }
-    if (isPunctuationChar.test(ch)) {
-      curPunc = ch;
-      return null;
-    }
     if (numberStart.test(ch)) {
       stream.backUp(1)
       if (stream.match(number)) return "number"
       stream.next()
     }
+    if (isPunctuationChar.test(ch)) {
+      curPunc = ch;
+      return null;
+    }
     if (ch == "/") {
       if (stream.eat("*")) {
         state.tokenize = tokenComment;
diff -pruN 5.58.2+~cs0.23.101-1/mode/clojure/clojure.js 5.59.0+~cs0.23.105-1/mode/clojure/clojure.js
--- 5.58.2+~cs0.23.101-1/mode/clojure/clojure.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/clojure/clojure.js	2020-12-20 10:48:25.000000000 +0000
@@ -160,10 +160,10 @@ CodeMirror.defineMode("clojure", functio
   var numberLiteral = /^(?:[+\-]?\d+(?:(?:N|(?:[eE][+\-]?\d+))|(?:\.?\d*(?:M|(?:[eE][+\-]?\d+))?)|\/\d+|[xX][0-9a-fA-F]+|r[0-9a-zA-Z]+)?(?=[\\\[\]\s"#'(),;@^`{}~]|$))/;
   var characterLiteral = /^(?:\\(?:backspace|formfeed|newline|return|space|tab|o[0-7]{3}|u[0-9A-Fa-f]{4}|x[0-9A-Fa-f]{4}|.)?(?=[\\\[\]\s"(),;@^`{}~]|$))/;
 
-  // simple-namespace := /^[^\\\/\[\]\d\s"#'(),;@^`{}~][^\\\[\]\s"(),;@^`{}~]*/
+  // simple-namespace := /^[^\\\/\[\]\d\s"#'(),;@^`{}~.][^\\\[\]\s"(),;@^`{}~.\/]*/
   // simple-symbol    := /^(?:\/|[^\\\/\[\]\d\s"#'(),;@^`{}~][^\\\[\]\s"(),;@^`{}~]*)/
   // qualified-symbol := (<simple-namespace>(<.><simple-namespace>)*</>)?<simple-symbol>
-  var qualifiedSymbol = /^(?:(?:[^\\\/\[\]\d\s"#'(),;@^`{}~][^\\\[\]\s"(),;@^`{}~]*(?:\.[^\\\/\[\]\d\s"#'(),;@^`{}~][^\\\[\]\s"(),;@^`{}~]*)*\/)?(?:\/|[^\\\/\[\]\d\s"#'(),;@^`{}~][^\\\[\]\s"(),;@^`{}~]*)*(?=[\\\[\]\s"(),;@^`{}~]|$))/;
+  var qualifiedSymbol = /^(?:(?:[^\\\/\[\]\d\s"#'(),;@^`{}~.][^\\\[\]\s"(),;@^`{}~.\/]*(?:\.[^\\\/\[\]\d\s"#'(),;@^`{}~.][^\\\[\]\s"(),;@^`{}~.\/]*)*\/)?(?:\/|[^\\\/\[\]\d\s"#'(),;@^`{}~][^\\\[\]\s"(),;@^`{}~]*)*(?=[\\\[\]\s"(),;@^`{}~]|$))/;
 
   function base(stream, state) {
     if (stream.eatSpace() || stream.eat(",")) return ["space", null];
diff -pruN 5.58.2+~cs0.23.101-1/mode/htmlmixed/htmlmixed.js 5.59.0+~cs0.23.105-1/mode/htmlmixed/htmlmixed.js
--- 5.58.2+~cs0.23.101-1/mode/htmlmixed/htmlmixed.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/htmlmixed/htmlmixed.js	2020-12-20 10:48:25.000000000 +0000
@@ -74,7 +74,8 @@
       name: "xml",
       htmlMode: true,
       multilineTagIndentFactor: parserConfig.multilineTagIndentFactor,
-      multilineTagIndentPastTag: parserConfig.multilineTagIndentPastTag
+      multilineTagIndentPastTag: parserConfig.multilineTagIndentPastTag,
+      allowMissingTagName: parserConfig.allowMissingTagName,
     });
 
     var tags = {};
diff -pruN 5.58.2+~cs0.23.101-1/mode/index.html 5.59.0+~cs0.23.105-1/mode/index.html
--- 5.58.2+~cs0.23.101-1/mode/index.html	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/index.html	2020-12-20 10:48:25.000000000 +0000
@@ -153,6 +153,7 @@ option.</p>
       <li><a href="vhdl/index.html">VHDL</a></li>
       <li><a href="vue/index.html">Vue.js app</a></li>
       <li><a href="webidl/index.html">Web IDL</a></li>
+      <li><a href="wast/index.html">WebAssembly Text Format</a></li>
       <li><a href="xml/index.html">XML/HTML</a></li>
       <li><a href="xquery/index.html">XQuery</a></li>
       <li><a href="yacas/index.html">Yacas</a></li>
diff -pruN 5.58.2+~cs0.23.101-1/mode/javascript/javascript.js 5.59.0+~cs0.23.105-1/mode/javascript/javascript.js
--- 5.58.2+~cs0.23.101-1/mode/javascript/javascript.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/javascript/javascript.js	2020-12-20 10:48:25.000000000 +0000
@@ -616,13 +616,18 @@ CodeMirror.defineMode("javascript", func
     if (value == "|" || value == "&") return cont(typeexpr)
     if (type == "string" || type == "number" || type == "atom") return cont(afterType);
     if (type == "[") return cont(pushlex("]"), commasep(typeexpr, "]", ","), poplex, afterType)
-    if (type == "{") return cont(pushlex("}"), commasep(typeprop, "}", ",;"), poplex, afterType)
+    if (type == "{") return cont(pushlex("}"), typeprops, poplex, afterType)
     if (type == "(") return cont(commasep(typearg, ")"), maybeReturnType, afterType)
     if (type == "<") return cont(commasep(typeexpr, ">"), typeexpr)
   }
   function maybeReturnType(type) {
     if (type == "=>") return cont(typeexpr)
   }
+  function typeprops(type) {
+    if (type == "}") return cont()
+    if (type == "," || type == ";") return cont(typeprops)
+    return pass(typeprop, typeprops)
+  }
   function typeprop(type, value) {
     if (type == "variable" || cx.style == "keyword") {
       cx.marked = "property"
diff -pruN 5.58.2+~cs0.23.101-1/mode/scheme/scheme.js 5.59.0+~cs0.23.105-1/mode/scheme/scheme.js
--- 5.58.2+~cs0.23.101-1/mode/scheme/scheme.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/scheme/scheme.js	2020-12-20 10:48:25.000000000 +0000
@@ -26,8 +26,8 @@ CodeMirror.defineMode("scheme", function
         return obj;
     }
 
-    var keywords = makeKeywords("λ case-lambda call/cc class define-class exit-handler field import inherit init-field interface let*-values let-values let/ec mixin opt-lambda override protect provide public rename require require-for-syntax syntax syntax-case syntax-error unit/sig unless when with-syntax and begin call-with-current-continuation call-with-input-file call-with-output-file case cond define define-syntax delay do dynamic-wind else for-each if lambda let let* let-syntax letrec letrec-syntax map or syntax-rules abs acos angle append apply asin assoc assq assv atan boolean? caar cadr call-with-input-file call-with-output-file call-with-values car cdddar cddddr cdr ceiling char->integer char-alphabetic? char-ci<=? char-ci<? char-ci=? char-ci>=? char-ci>? char-downcase char-lower-case? char-numeric? char-ready? char-upcase char-upper-case? char-whitespace? char<=? char<? char=? char>=? char>? char? close-input-port close-output-port complex? cons cos current-input-port current-output-port denominator display eof-object? eq? equal? eqv? eval even? exact->inexact exact? exp expt #f floor force gcd imag-part inexact->exact inexact? input-port? integer->char integer? interaction-environment lcm length list list->string list->vector list-ref list-tail list? load log magnitude make-polar make-rectangular make-string make-vector max member memq memv min modulo negative? newline not null-environment null? number->string number? numerator odd? open-input-file open-output-file output-port? pair? peek-char port? positive? procedure? quasiquote quote quotient rational? rationalize read read-char real-part real? remainder reverse round scheme-report-environment set! set-car! set-cdr! sin sqrt string string->list string->number string->symbol string-append string-ci<=? string-ci<? string-ci=? string-ci>=? string-ci>? string-copy string-fill! string-length string-ref string-set! string<=? string<? string=? string>=? string>? string? substring symbol->string symbol? #t tan transcript-off transcript-on truncate values vector vector->list vector-fill! vector-length vector-ref vector-set! with-input-from-file with-output-to-file write write-char zero?");
-    var indentKeys = makeKeywords("define let letrec let* lambda");
+    var keywords = makeKeywords("λ case-lambda call/cc class cond-expand define-class define-values exit-handler field import inherit init-field interface let*-values let-values let/ec mixin opt-lambda override protect provide public rename require require-for-syntax syntax syntax-case syntax-error unit/sig unless when with-syntax and begin call-with-current-continuation call-with-input-file call-with-output-file case cond define define-syntax define-macro defmacro delay do dynamic-wind else for-each if lambda let let* let-syntax letrec letrec-syntax map or syntax-rules abs acos angle append apply asin assoc assq assv atan boolean? caar cadr call-with-input-file call-with-output-file call-with-values car cdddar cddddr cdr ceiling char->integer char-alphabetic? char-ci<=? char-ci<? char-ci=? char-ci>=? char-ci>? char-downcase char-lower-case? char-numeric? char-ready? char-upcase char-upper-case? char-whitespace? char<=? char<? char=? char>=? char>? char? close-input-port close-output-port complex? cons cos current-input-port current-output-port denominator display eof-object? eq? equal? eqv? eval even? exact->inexact exact? exp expt #f floor force gcd imag-part inexact->exact inexact? input-port? integer->char integer? interaction-environment lcm length list list->string list->vector list-ref list-tail list? load log magnitude make-polar make-rectangular make-string make-vector max member memq memv min modulo negative? newline not null-environment null? number->string number? numerator odd? open-input-file open-output-file output-port? pair? peek-char port? positive? procedure? quasiquote quote quotient rational? rationalize read read-char real-part real? remainder reverse round scheme-report-environment set! set-car! set-cdr! sin sqrt string string->list string->number string->symbol string-append string-ci<=? string-ci<? string-ci=? string-ci>=? string-ci>? string-copy string-fill! string-length string-ref string-set! string<=? string<? string=? string>=? string>? string? substring symbol->string symbol? #t tan transcript-off transcript-on truncate values vector vector->list vector-fill! vector-length vector-ref vector-set! with-input-from-file with-output-to-file write write-char zero?");
+    var indentKeys = makeKeywords("define let letrec let* lambda define-macro defmacro let-syntax letrec-syntax let-values let*-values define-syntax syntax-rules define-values when unless");
 
     function stateStack(indent, type, prev) { // represents a state stack object
         this.indent = indent;
diff -pruN 5.58.2+~cs0.23.101-1/mode/shell/shell.js 5.59.0+~cs0.23.105-1/mode/shell/shell.js
--- 5.58.2+~cs0.23.101-1/mode/shell/shell.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/shell/shell.js	2020-12-20 10:48:25.000000000 +0000
@@ -70,6 +70,14 @@ CodeMirror.defineMode('shell', function(
       stream.eatWhile(/\w/);
       return 'attribute';
     }
+    if (ch == "<") {
+      if (stream.match("<<")) return "operator"
+      var heredoc = stream.match(/^<-?\s*['"]?([^'"]*)['"]?/)
+      if (heredoc) {
+        state.tokens.unshift(tokenHeredoc(heredoc[1]))
+        return 'string-2'
+      }
+    }
     if (/\d/.test(ch)) {
       stream.eatWhile(/\d/);
       if(stream.eol() || !/\w/.test(stream.peek())) {
@@ -129,6 +137,14 @@ CodeMirror.defineMode('shell', function(
     return 'def';
   };
 
+  function tokenHeredoc(delim) {
+    return function(stream, state) {
+      if (stream.sol() && stream.string == delim) state.tokens.shift()
+      stream.skipToEnd()
+      return "string-2"
+    }
+  }
+
   function tokenize(stream, state) {
     return (state.tokens[0] || tokenBase) (stream, state);
   };
diff -pruN 5.58.2+~cs0.23.101-1/mode/shell/test.js 5.59.0+~cs0.23.105-1/mode/shell/test.js
--- 5.58.2+~cs0.23.101-1/mode/shell/test.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/shell/test.js	2020-12-20 10:48:25.000000000 +0000
@@ -65,9 +65,16 @@
   MT("strings in parens",
      "[def FOO][operator =]([quote $(<][string \"][def $MYDIR][string \"][quote /myfile grep ][string 'hello$'][quote )])")
 
-  MT ("string ending in dollar",
-     '[def a][operator =][string "xyz$"]; [def b][operator =][string "y"]')
+  MT("string ending in dollar",
+    '[def a][operator =][string "xyz$"]; [def b][operator =][string "y"]')
 
-  MT ("quote ending in dollar",
-     "[quote $(echo a$)]")
+  MT("quote ending in dollar",
+    "[quote $(echo a$)]")
+
+  MT("heredoc",
+     "[builtin cat] [string-2 <<- end]",
+     "[string-2 content one]",
+     "[string-2 content two end]",
+     "[string-2 end]",
+     "[builtin echo]")
 })();
diff -pruN 5.58.2+~cs0.23.101-1/mode/soy/soy.js 5.59.0+~cs0.23.105-1/mode/soy/soy.js
--- 5.58.2+~cs0.23.101-1/mode/soy/soy.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/soy/soy.js	2020-12-20 10:48:25.000000000 +0000
@@ -16,6 +16,8 @@
     "alias": { noEndTag: true },
     "delpackage": { noEndTag: true },
     "namespace": { noEndTag: true, soyState: "namespace-def" },
+    "@attribute": paramData,
+    "@attribute?": paramData,
     "@param": paramData,
     "@param?": paramData,
     "@inject": paramData,
@@ -53,7 +55,7 @@
   CodeMirror.defineMode("soy", function(config) {
     var textMode = CodeMirror.getMode(config, "text/plain");
     var modes = {
-      html: CodeMirror.getMode(config, {name: "text/html", multilineTagIndentFactor: 2, multilineTagIndentPastTag: false}),
+      html: CodeMirror.getMode(config, {name: "text/html", multilineTagIndentFactor: 2, multilineTagIndentPastTag: false, allowMissingTagName: true}),
       attributes: textMode,
       text: textMode,
       uri: textMode,
@@ -274,6 +276,11 @@
             return null;
 
           case "param-def":
+            if (match = stream.match(/^\*/)) {
+              state.soyState.pop();
+              state.soyState.push("param-type");
+              return "type";
+            }
             if (match = stream.match(/^\w+/)) {
               state.variables = prepend(state.variables, match[0]);
               state.soyState.pop();
@@ -456,8 +463,15 @@
             return null;
 
           case "tag":
-            var endTag = state.tag[0] == "/";
-            var tagName = endTag ? state.tag.substring(1) : state.tag;
+            var endTag;
+            var tagName;
+            if (state.tag === undefined) {
+              endTag = true;
+              tagName = '';
+            } else {
+              endTag = state.tag[0] == "/";
+              tagName = endTag ? state.tag.substring(1) : state.tag;
+            }
             var tag = tags[tagName];
             if (stream.match(/^\/?}/)) {
               var selfClosed = stream.current() == "/}";
@@ -491,6 +505,17 @@
             }
             return expression(stream, state);
 
+          case "template-call-expression":
+            if (stream.match(/^([\w-?]+)(?==)/)) {
+              return "attribute";
+            } else if (stream.eat('>')) {
+              state.soyState.pop();
+              return "keyword";
+            } else if (stream.eat('/>')) {
+              state.soyState.pop();
+              return "keyword";
+            }
+            return expression(stream, state);
           case "literal":
             if (stream.match(/^(?=\{\/literal})/)) {
               state.soyState.pop();
@@ -556,6 +581,14 @@
           state.soyState.push("import");
           state.indent += 2 * config.indentUnit;
           return "keyword";
+        } else if (match = stream.match(/^<\{/)) {
+          state.soyState.push("template-call-expression");
+          state.indent += 2 * config.indentUnit;
+          state.soyState.push("tag");
+          return "keyword";
+        } else if (match = stream.match(/^<\/>/)) {
+          state.indent -= 1 * config.indentUnit;
+          return "keyword";
         }
 
         return tokenUntil(stream, state, /\{|\s+\/\/|\/\*/);
diff -pruN 5.58.2+~cs0.23.101-1/mode/soy/test.js 5.59.0+~cs0.23.105-1/mode/soy/test.js
--- 5.58.2+~cs0.23.101-1/mode/soy/test.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/soy/test.js	2020-12-20 10:48:25.000000000 +0000
@@ -26,6 +26,15 @@
      '[keyword {] [callee&variable index]([variable-2&error $list])[keyword }]' +
         '[string "][tag&bracket />]');
 
+  MT('soy-element-composition-test',
+     '[keyword <{][callee&variable foo]()[keyword }]',
+     '[keyword ></>]');
+
+  MT('soy-element-composition-attribute-test',
+     '[keyword <{][callee&variable foo]()[keyword }]',
+     '[attribute class]=[string "Foo"]',
+     '[keyword ></>]');
+
   MT('namespace-test',
      '[keyword {namespace] [variable namespace][keyword }]')
 
@@ -176,6 +185,24 @@
      '[keyword {/template}]',
      '');
 
+  MT('attribute-type',
+     '[keyword {template] [def .foo][keyword }]',
+     '  [keyword {@attribute] [def bar]: [type string][keyword }]',
+     '[keyword {/template}]',
+     '');
+
+  MT('attribute-type-optional',
+     '[keyword {template] [def .foo][keyword }]',
+     '  [keyword {@attribute] [def bar]: [type string][keyword }]',
+     '[keyword {/template}]',
+     '');
+
+  MT('attribute-type-all',
+     '[keyword {template] [def .foo][keyword }]',
+     '  [keyword {@attribute] [type *][keyword }]',
+     '[keyword {/template}]',
+     '');
+
    MT('state-variable-reference',
      '[keyword {template] [def .foo][keyword }]',
      '  [keyword {@param] [def bar]:= [atom true][keyword }]',
diff -pruN 5.58.2+~cs0.23.101-1/mode/stylus/stylus.js 5.59.0+~cs0.23.105-1/mode/stylus/stylus.js
--- 5.58.2+~cs0.23.101-1/mode/stylus/stylus.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/stylus/stylus.js	2020-12-20 10:48:25.000000000 +0000
@@ -722,6 +722,9 @@
         return indent;
       },
       electricChars: "}",
+      blockCommentStart: "/*",
+      blockCommentEnd: "*/",
+      blockCommentContinue: " * ",
       lineComment: "//",
       fold: "indent"
     };
diff -pruN 5.58.2+~cs0.23.101-1/mode/verilog/test.js 5.59.0+~cs0.23.105-1/mode/verilog/test.js
--- 5.58.2+~cs0.23.101-1/mode/verilog/test.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/verilog/test.js	2020-12-20 10:48:25.000000000 +0000
@@ -139,6 +139,32 @@
      ""
   );
 
+  MT("align_assignments",
+     /**
+      * always @(posedge clk) begin
+      *    if (rst)
+      *       data_out <= 8'b0 +
+      *                   8'b1;
+      *    else
+      *       data_out = 8'b0 +
+      *                  8'b1;
+      *    data_out =
+      *       8'b0 + 8'b1;
+      * end
+      */
+     "[keyword always] [def @][bracket (][keyword posedge] [variable clk][bracket )] [keyword begin]",
+     "    [keyword if] [bracket (][variable rst][bracket )]",
+     "        [variable data_out] [meta <=] [number 8'b0] [meta +]",
+     "                    [number 8'b1];",
+     "    [keyword else]",
+     "        [variable data_out] [meta =] [number 8'b0] [meta +]",
+     "                   [number 8'b1];",
+     "    [variable data_out] [meta =] [number 8'b0] [meta +]",
+     "               [number 8'b1];",
+     "[keyword end]",
+     ""
+  );
+
   // Indentation tests
   MT("indent_single_statement_if",
       "[keyword if] [bracket (][variable foo][bracket )]",
@@ -270,4 +296,148 @@
     ""
   );
 
+  MT("indent_uvm_macros",
+     /**
+      *  `uvm_object_utils_begin(foo)
+      *    `uvm_field_event(foo, UVM_ALL_ON)
+      *  `uvm_object_utils_end
+      */
+     "[def `uvm_object_utils_begin][bracket (][variable foo][bracket )]",
+     "    [def `uvm_field_event][bracket (][variable foo], [variable UVM_ALL_ON][bracket )]",
+     "[def `uvm_object_utils_end]",
+     ""
+  );
+
+  MT("indent_uvm_macros2",
+     /**
+      * `uvm_do_with(mem_read,{
+      *    bar_nb == 0;
+      * })
+      */
+     "[def `uvm_do_with][bracket (][variable mem_read],[bracket {]",
+     "    [variable bar_nb] [meta ==] [number 0];",
+     "[bracket })]",
+     ""
+  );
+
+  MT("indent_wait_disable_fork",
+     /**
+      * virtual task body();
+      *    repeat (20) begin
+      *       fork
+      *          `uvm_create_on(t,p_seq)
+      *       join_none
+      *    end
+      *    wait fork;
+      *    disable fork;
+      * endtask : body
+      */
+     "[keyword virtual] [keyword task] [variable body][bracket ()];",
+     "    [keyword repeat] [bracket (][number 20][bracket )] [keyword begin]",
+     "        [keyword fork]",
+     "            [def `uvm_create_on][bracket (][variable t],[variable p_seq][bracket )]",
+     "        [keyword join_none]",
+     "    [keyword end]",
+     "    [keyword wait] [keyword fork];",
+     "    [keyword disable] [keyword fork];",
+     "[keyword endtask] : [variable body]",
+     ""
+  );
+
+  MT("indent_typedef_class",
+     /**
+      * typedef class asdf;
+      * typedef p p_t[];
+      * typedef enum {
+      *    ASDF
+      * } t;
+      */
+     "[keyword typedef] [keyword class] [variable asdf];",
+     "[keyword typedef] [variable p] [variable p_t][bracket [[]]];",
+     "[keyword typedef] [keyword enum] [bracket {]",
+     "    [variable ASDF]",
+     "[bracket }] [variable t];",
+     ""
+  );
+
+  MT("indent_case_with_macro",
+     /**
+      * // It should be assumed that Macros can have ';' inside, or 'begin'/'end' blocks.
+      * // As such, 'case' statement should indent correctly with macros inside.
+      * case(foo)
+      *    ASDF : this.foo = seqNum;
+      *    ABCD : `update(f)
+      *    EFGH : `update(g)
+      * endcase
+      */
+     "[keyword case][bracket (][variable foo][bracket )]",
+     "    [variable ASDF] : [keyword this].[variable foo] [meta =] [variable seqNum];",
+     "    [variable ABCD] : [def `update][bracket (][variable f][bracket )]",
+     "    [variable EFGH] : [def `update][bracket (][variable g][bracket )]",
+     "[keyword endcase]",
+     ""
+  );
+
+  MT("indent_extern_function",
+     /**
+      * extern virtual function void do(ref packet trans);
+      * extern virtual function void do2(ref packet trans);
+      */
+     "[keyword extern] [keyword virtual] [keyword function] [keyword void] [variable do1][bracket (][keyword ref] [variable packet] [variable trans][bracket )];",
+     "[keyword extern] [keyword virtual] [keyword function] [keyword void] [variable do2][bracket (][keyword ref] [variable packet] [variable trans][bracket )];",
+     ""
+  );
+
+  MT("indent_assignment",
+     /**
+      * for (int i=1;i < fun;i++) begin
+      *    foo = 2 << asdf || 11'h35 >> abcd
+      *          && 8'h6 | 1'b1;
+      * end
+      */
+     "[keyword for] [bracket (][keyword int] [variable i][meta =][number 1];[variable i] [meta <] [variable fun];[variable i][meta ++][bracket )] [keyword begin]",
+     "    [variable foo] [meta =] [number 2] [meta <<] [variable asdf] [meta ||] [number 11'h35] [meta >>] [variable abcd]",
+     "          [meta &&] [number 8'h6] [meta |] [number 1'b1];",
+     "[keyword end]",
+     ""
+  );
+
+  MT("indent_foreach_constraint",
+     /**
+      * `uvm_rand_send_with(wrTlp, {
+      *    length ==1;
+      *    foreach (Data[i]) {
+      *       payload[i] == Data[i];
+      *    }
+      * })
+      */
+     "[def `uvm_rand_send_with][bracket (][variable wrTlp], [bracket {]",
+     "    [variable length] [meta ==][number 1];",
+     "    [keyword foreach] [bracket (][variable Data][bracket [[][variable i][bracket ]])] [bracket {]",
+     "        [variable payload][bracket [[][variable i][bracket ]]] [meta ==] [variable Data][bracket [[][variable i][bracket ]]];",
+     "    [bracket }]",
+     "[bracket })]",
+     ""
+  );
+
+  MT("indent_compiler_directives",
+     /**
+      * `ifdef DUT
+      * `else
+      *     `ifndef FOO
+      *         `define FOO
+      *     `endif
+      * `endif
+      * `timescale 1ns/1ns
+      */
+     "[def `ifdef] [variable DUT]",
+     "[def `else]",
+     "    [def `ifndef] [variable FOO]",
+     "        [def `define] [variable FOO]",
+     "    [def `endif]",
+     "[def `endif]",
+     "[def `timescale] [number 1][variable ns][meta /][number 1][variable ns]",
+     ""
+  );
+
 })();
diff -pruN 5.58.2+~cs0.23.101-1/mode/verilog/verilog.js 5.59.0+~cs0.23.105-1/mode/verilog/verilog.js
--- 5.58.2+~cs0.23.101-1/mode/verilog/verilog.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/verilog/verilog.js	2020-12-20 10:48:25.000000000 +0000
@@ -16,6 +16,12 @@ CodeMirror.defineMode("verilog", functio
   var indentUnit = config.indentUnit,
       statementIndentUnit = parserConfig.statementIndentUnit || indentUnit,
       dontAlignCalls = parserConfig.dontAlignCalls,
+      // compilerDirectivesUseRegularIndentation - If set, Compiler directive
+      // indentation follows the same rules as everything else. Otherwise if
+      // false, compiler directives will track their own indentation.
+      // For example, `ifdef nested inside another `ifndef will be indented,
+      // but a `ifdef inside a function block may not be indented.
+      compilerDirectivesUseRegularIndentation = parserConfig.compilerDirectivesUseRegularIndentation,
       noIndentKeywords = parserConfig.noIndentKeywords || [],
       multiLineStrings = parserConfig.multiLineStrings,
       hooks = parserConfig.hooks || {};
@@ -62,7 +68,7 @@ CodeMirror.defineMode("verilog", functio
      binary_module_path_operator ::=
        == | != | && | || | & | | | ^ | ^~ | ~^
   */
-  var isOperatorChar = /[\+\-\*\/!~&|^%=?:]/;
+  var isOperatorChar = /[\+\-\*\/!~&|^%=?:<>]/;
   var isBracketChar = /[\[\]{}()]/;
 
   var unsignedNumber = /\d[0-9_]*/;
@@ -72,8 +78,13 @@ CodeMirror.defineMode("verilog", functio
   var hexLiteral = /\d*\s*'s?h\s*[0-9a-fxz?][0-9a-fxz?_]*/i;
   var realLiteral = /(\d[\d_]*(\.\d[\d_]*)?E-?[\d_]+)|(\d[\d_]*\.\d[\d_]*)/i;
 
-  var closingBracketOrWord = /^((\w+)|[)}\]])/;
+  var closingBracketOrWord = /^((`?\w+)|[)}\]])/;
   var closingBracket = /[)}\]]/;
+  var compilerDirectiveRegex      = new RegExp(
+    "^(`(?:ifdef|ifndef|elsif|else|endif|undef|undefineall|define|include|begin_keywords|celldefine|default|" +
+    "nettype|end_keywords|endcelldefine|line|nounconnected_drive|pragma|resetall|timescale|unconnected_drive))\\b");
+  var compilerDirectiveBeginRegex = /^(`(?:ifdef|ifndef|elsif|else))\b/;
+  var compilerDirectiveEndRegex   = /^(`(?:elsif|else|endif))\b/;
 
   var curPunc;
   var curKeyword;
@@ -96,6 +107,7 @@ CodeMirror.defineMode("verilog", functio
   openClose["do"   ] = "while";
   openClose["fork" ] = "join;join_any;join_none";
   openClose["covergroup"] = "endgroup";
+  openClose["macro_begin"] = "macro_end";
 
   for (var i in noIndentKeywords) {
     var keyword = noIndentKeywords[i];
@@ -105,7 +117,7 @@ CodeMirror.defineMode("verilog", functio
   }
 
   // Keywords which open statements that are ended with a semi-colon
-  var statementKeywords = words("always always_comb always_ff always_latch assert assign assume else export for foreach forever if import initial repeat while");
+  var statementKeywords = words("always always_comb always_ff always_latch assert assign assume else export for foreach forever if import initial repeat while extern typedef");
 
   function tokenBase(stream, state) {
     var ch = stream.peek(), style;
@@ -125,6 +137,23 @@ CodeMirror.defineMode("verilog", functio
     if (ch == '`') {
       stream.next();
       if (stream.eatWhile(/[\w\$_]/)) {
+        var cur = stream.current();
+        curKeyword = cur;
+        // Macros that end in _begin, are start of block and end with _end
+        if (cur.startsWith("`uvm_") && cur.endsWith("_begin")) {
+          var keywordClose = curKeyword.substr(0,curKeyword.length - 5) + "end";
+          openClose[cur] = keywordClose;
+          curPunc = "newblock";
+        } else {
+          stream.eatSpace();
+          if (stream.peek() == '(') {
+            // Check if this is a block
+            curPunc = "newmacro";
+          }
+          var withSpace = stream.current();
+          // Move the stream back before the spaces
+          stream.backUp(withSpace.length - cur.length);
+        }
         return "def";
       } else {
         return null;
@@ -145,6 +174,12 @@ CodeMirror.defineMode("verilog", functio
       stream.eatWhile(/[\d_.]/);
       return "def";
     }
+    // Event
+    if (ch == '@') {
+      stream.next();
+      stream.eatWhile(/[@]/);
+      return "def";
+    }
     // Strings
     if (ch == '"') {
       stream.next();
@@ -178,6 +213,7 @@ CodeMirror.defineMode("verilog", functio
 
     // Operators
     if (stream.eatWhile(isOperatorChar)) {
+      curPunc = stream.current();
       return "meta";
     }
 
@@ -187,6 +223,15 @@ CodeMirror.defineMode("verilog", functio
       if (keywords[cur]) {
         if (openClose[cur]) {
           curPunc = "newblock";
+          if (cur === "fork") {
+            // Fork can be a statement instead of block in cases of:
+            // "disable fork;" and "wait fork;" (trailing semicolon)
+            stream.eatSpace()
+            if (stream.peek() == ';') {
+              curPunc = "newstatement";
+            }
+            stream.backUp(stream.current().length - cur.length);
+          }
         }
         if (statementKeywords[cur]) {
           curPunc = "newstatement";
@@ -226,16 +271,17 @@ CodeMirror.defineMode("verilog", functio
     return "comment";
   }
 
-  function Context(indented, column, type, align, prev) {
+  function Context(indented, column, type, scopekind, align, prev) {
     this.indented = indented;
     this.column = column;
     this.type = type;
+    this.scopekind = scopekind;
     this.align = align;
     this.prev = prev;
   }
-  function pushContext(state, col, type) {
+  function pushContext(state, col, type, scopekind) {
     var indent = state.indented;
-    var c = new Context(indent, col, type, null, state.context);
+    var c = new Context(indent, col, type, scopekind ? scopekind : "", null, state.context);
     return state.context = c;
   }
   function popContext(state) {
@@ -261,6 +307,16 @@ CodeMirror.defineMode("verilog", functio
     }
   }
 
+  function isInsideScopeKind(ctx, scopekind) {
+    if (ctx == null) {
+      return false;
+    }
+    if (ctx.scopekind === scopekind) {
+      return true;
+    }
+    return isInsideScopeKind(ctx.prev, scopekind);
+  }
+
   function buildElectricInputRegEx() {
     // Reindentation should occur on any bracket char: {}()[]
     // or on a match of any of the block closing keywords, at
@@ -287,8 +343,9 @@ CodeMirror.defineMode("verilog", functio
     startState: function(basecolumn) {
       var state = {
         tokenize: null,
-        context: new Context((basecolumn || 0) - indentUnit, 0, "top", false),
+        context: new Context((basecolumn || 0) - indentUnit, 0, "top", "top", false),
         indented: 0,
+        compilerDirectiveIndented: 0,
         startOfLine: true
       };
       if (hooks.startState) hooks.startState(state);
@@ -313,15 +370,42 @@ CodeMirror.defineMode("verilog", functio
       curPunc = null;
       curKeyword = null;
       var style = (state.tokenize || tokenBase)(stream, state);
-      if (style == "comment" || style == "meta" || style == "variable") return style;
+      if (style == "comment" || style == "meta" || style == "variable") {
+        if (((curPunc === "=") || (curPunc === "<=")) && !isInsideScopeKind(ctx, "assignment")) {
+          // '<=' could be nonblocking assignment or lessthan-equals (which shouldn't cause indent)
+          //      Search through the context to see if we are already in an assignment.
+          // '=' could be inside port declaration with comma or ')' afterward, or inside for(;;) block.
+          pushContext(state, stream.column() + curPunc.length, "assignment", "assignment");
+          if (ctx.align == null) ctx.align = true;
+        }
+        return style;
+      }
       if (ctx.align == null) ctx.align = true;
 
-      if (curPunc == ctx.type) {
-        popContext(state);
-      } else if ((curPunc == ";" && ctx.type == "statement") ||
+      var isClosingAssignment = ctx.type == "assignment" &&
+        closingBracket.test(curPunc) && ctx.prev && ctx.prev.type === curPunc;
+      if (curPunc == ctx.type || isClosingAssignment) {
+        if (isClosingAssignment) {
+          ctx = popContext(state);
+        }
+        ctx = popContext(state);
+        if (curPunc == ")") {
+          // Handle closing macros, assuming they could have a semicolon or begin/end block inside.
+          if (ctx && (ctx.type === "macro")) {
+            ctx = popContext(state);
+            while (ctx && (ctx.type == "statement" || ctx.type == "assignment")) ctx = popContext(state);
+          }
+        } else if (curPunc == "}") {
+          // Handle closing statements like constraint block: "foreach () {}" which
+          // do not have semicolon at end.
+          if (ctx && (ctx.type === "statement")) {
+            while (ctx && (ctx.type == "statement")) ctx = popContext(state);
+          }
+        }
+      } else if (((curPunc == ";" || curPunc == ",") && (ctx.type == "statement" || ctx.type == "assignment")) ||
                (ctx.type && isClosing(curKeyword, ctx.type))) {
         ctx = popContext(state);
-        while (ctx && ctx.type == "statement") ctx = popContext(state);
+        while (ctx && (ctx.type == "statement" || ctx.type == "assignment")) ctx = popContext(state);
       } else if (curPunc == "{") {
         pushContext(state, stream.column(), "}");
       } else if (curPunc == "[") {
@@ -329,9 +413,9 @@ CodeMirror.defineMode("verilog", functio
       } else if (curPunc == "(") {
         pushContext(state, stream.column(), ")");
       } else if (ctx && ctx.type == "endcase" && curPunc == ":") {
-        pushContext(state, stream.column(), "statement");
+        pushContext(state, stream.column(), "statement", "case");
       } else if (curPunc == "newstatement") {
-        pushContext(state, stream.column(), "statement");
+        pushContext(state, stream.column(), "statement", curKeyword);
       } else if (curPunc == "newblock") {
         if (curKeyword == "function" && ctx && (ctx.type == "statement" || ctx.type == "endgroup")) {
           // The 'function' keyword can appear in some other contexts where it actually does not
@@ -339,9 +423,23 @@ CodeMirror.defineMode("verilog", functio
           // Do nothing in this case
         } else if (curKeyword == "task" && ctx && ctx.type == "statement") {
           // Same thing for task
+        } else if (curKeyword == "class" && ctx && ctx.type == "statement") {
+          // Same thing for class (e.g. typedef)
         } else {
           var close = openClose[curKeyword];
-          pushContext(state, stream.column(), close);
+          pushContext(state, stream.column(), close, curKeyword);
+        }
+      } else if (curPunc == "newmacro" || (curKeyword && curKeyword.match(compilerDirectiveRegex))) {
+        if (curPunc == "newmacro") {
+          // Macros (especially if they have parenthesis) potentially have a semicolon
+          // or complete statement/block inside, and should be treated as such.
+          pushContext(state, stream.column(), "macro", "macro");
+        }
+        if (curKeyword.match(compilerDirectiveEndRegex)) {
+          state.compilerDirectiveIndented -= statementIndentUnit;
+        }
+        if (curKeyword.match(compilerDirectiveBeginRegex)) {
+          state.compilerDirectiveIndented += statementIndentUnit;
         }
       }
 
@@ -361,8 +459,15 @@ CodeMirror.defineMode("verilog", functio
       var possibleClosing = textAfter.match(closingBracketOrWord);
       if (possibleClosing)
         closing = isClosing(possibleClosing[0], ctx.type);
+      if (!compilerDirectivesUseRegularIndentation && textAfter.match(compilerDirectiveRegex)) {
+        if (textAfter.match(compilerDirectiveEndRegex)) {
+          return state.compilerDirectiveIndented - statementIndentUnit;
+        }
+        return state.compilerDirectiveIndented;
+      }
       if (ctx.type == "statement") return ctx.indented + (firstChar == "{" ? 0 : statementIndentUnit);
-      else if (closingBracket.test(ctx.type) && ctx.align && !dontAlignCalls) return ctx.column + (closing ? 0 : 1);
+      else if ((closingBracket.test(ctx.type) || ctx.type == "assignment")
+        && ctx.align && !dontAlignCalls) return ctx.column + (closing ? 0 : 1);
       else if (ctx.type == ")" && !closing) return ctx.indented + statementIndentUnit;
       else return ctx.indented + (closing ? 0 : indentUnit);
     },
diff -pruN 5.58.2+~cs0.23.101-1/mode/wast/test.js 5.59.0+~cs0.23.105-1/mode/wast/test.js
--- 5.58.2+~cs0.23.101-1/mode/wast/test.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/wast/test.js	2020-12-20 10:48:25.000000000 +0000
@@ -21,7 +21,8 @@
      '[string "foo #\\"# bar"]');
 
   MT('atom-test',
-     '[atom anyfunc]',
+     '[atom funcref]',
+     '[atom externref]',
      '[atom i32]',
      '[atom i64]',
      '[atom f32]',
@@ -42,9 +43,11 @@
      '[keyword br_table] [variable-2 $label0] [variable-2 $label1] [variable-2 $label3]',
      '[keyword return]',
      '[keyword call] [variable-2 $func0]',
-     '[keyword call_indirect] ([keyword param] [atom f32] [atom f64]) ([keyword result] [atom i32] [atom i64])',
+     '[keyword call_indirect] [variable-2 $table] ([keyword param] [atom f32] [atom f64]) ([keyword result] [atom i32] [atom i64])',
      '[keyword return_call] [variable-2 $func0]',
-     '[keyword return_call_indirect] ([keyword param] [atom f32] [atom f64]) ([keyword result] [atom i32] [atom i64])');
+     '[keyword return_call_indirect] ([keyword param] [atom f32] [atom f64]) ([keyword result] [atom i32] [atom i64])',
+     '[keyword select] ([keyword local.get] [number 1]) ([keyword local.get] [number 2]) ([keyword local.get] [number 3])');
+
 
   MT('memory-instructions',
      '[keyword i32.load] [keyword offset]=[number 4] [keyword align]=[number 4]',
@@ -318,4 +321,20 @@
      '[keyword i32x4.trunc_sat_f32x4_u]',
      '[keyword f32x4.convert_i32x4_s]',
      '[keyword f32x4.convert_i32x4_u]');
+
+     MT('reference-type-instructions',
+     '[keyword ref.null] [keyword extern]',
+     '[keyword ref.null] [keyword func]',
+     '[keyword ref.is_null] ([keyword ref.func] [variable-2 $f])',
+     '[keyword ref.func] [variable-2 $f]');
+
+     MT('table-instructions',
+     '[keyword table.get] [variable-2 $t] ([keyword i32.const] [number 5])',
+     '[keyword table.set] [variable-2 $t] ([keyword i32.const] [number 5]) ([keyword ref.func] [variable-2 $f])',
+     '[keyword table.size] [variable-2 $t]',
+     '[keyword table.grow] [variable-2 $t] ([keyword ref.null] [keyword extern]) ([keyword i32.const] [number 5])',
+     '[keyword table.fill] [variable-2 $t] ([keyword i32.const] [number 5]) ([keyword param] [variable-2 $r] [atom externref]) ([keyword i32.const] [number 5])',
+     '[keyword table.init] [variable-2 $t] [number 1] ([keyword i32.const] [number 5]) ([keyword i32.const] [number 10]) ([keyword i32.const] [number 15])',
+     '[keyword table.copy] [variable-2 $t] [variable-2 $t2] ([keyword i32.const] [number 5]) ([keyword i32.const] [number 10]) ([keyword i32.const] [number 15])'
+     );
 })();
diff -pruN 5.58.2+~cs0.23.101-1/mode/wast/wast.js 5.59.0+~cs0.23.105-1/mode/wast/wast.js
--- 5.58.2+~cs0.23.101-1/mode/wast/wast.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/wast/wast.js	2020-12-20 10:48:25.000000000 +0000
@@ -14,8 +14,8 @@
 CodeMirror.defineSimpleMode('wast', {
   start: [
     {regex: /[+\-]?(?:nan(?::0x[0-9a-fA-F]+)?|infinity|inf|0x[0-9a-fA-F]+\.?[0-9a-fA-F]*p[+\/-]?\d+|\d+(?:\.\d*)?[eE][+\-]?\d*|\d+\.\d*|0x[0-9a-fA-F]+|\d+)/, token: "number"},
-    {regex: /mut|nop|block|if|then|else|loop|br_if|br_table|br|call(_indirect)?|drop|end|return(_call(_indirect)?)?|local\.(get|set|tee)|global\.(get|set)|i(32|64)\.(store(8|16)|(load(8|16)_[su]))|i64\.(load32_[su]|store32)|[fi](32|64)\.(const|load|store)|f(32|64)\.(abs|add|ceil|copysign|div|eq|floor|[gl][et]|max|min|mul|nearest|neg?|sqrt|sub|trunc)|i(32|64)\.(a[dn]d|c[lt]z|(div|rem)_[su]|eqz?|[gl][te]_[su]|mul|ne|popcnt|rot[lr]|sh(l|r_[su])|sub|x?or)|i64\.extend_[su]_i32|i32\.wrap_i64|i(32|64)\.trunc_f(32|64)_[su]|f(32|64)\.convert_i(32|64)_[su]|f64\.promote_f32|f32\.demote_f64|f32\.reinterpret_i32|i32\.reinterpret_f32|f64\.reinterpret_i64|i64\.reinterpret_f64|select|unreachable|current_memory|memory(\.((atomic\.(notify|wait(32|64)))|grow|size))?|type|func|param|result|local|global|module|table|start|elem|data|align|offset|import|export|i64\.atomic\.(load32_u|store32|rmw32\.(a[dn]d|sub|x?or|(cmp)?xchg)_u)|i(32|64)\.atomic\.(load((8|16)_u)?|store(8|16)?|rmw(\.(a[dn]d|sub|x?or|(cmp)?xchg)|(8|16)\.(a[dn]d|sub|x?or|(cmp)?xchg)_u))|v128\.(load|store|const|not|andnot|and|or|xor|bitselect)|i(8x16|16x8|32x4|64x2)\.(shl|shr_[su])|i(8x16|16x8)\.(extract_lane_[su]|((add|sub)_saturate_[su])|avgr_u)|(i(8x16|16x8|32x4|64x2)|f(32x4|64x2))\.(splat|replace_lane|neg|add|sub)|i(8x16|16x8|32x4)\.(eq|ne|([lg][te]_[su])|abs|any_true|all_true|bitmask|((min|max)_[su]))|f(32x4|64x2)\.(eq|ne|[lg][te]|abs|sqrt|mul|div|min|max)|[fi](32x4|64x2)\.extract_lane|v8x16\.(shuffle|swizzle)|i16x8\.(load8x8_[su]|narrow_i32x4_[su]|widen_(low|high)_i8x16_[su]|mul)|i32x4\.(load16x4_[su]|widen_(low|high)_i16x8_[su]|mul|trunc_sat_f32x4_[su])|i64x2\.(load32x2_[su]|mul)|(v(8x16|16x8|32x4|64x2)\.load_splat)|i8x16\.narrow_i16x8_[su]|f32x4\.convert_i32x4_[su]/, token: "keyword"},
-    {regex: /\b(anyfunc|[fi](32|64))\b/, token: "atom"},
+    {regex: /mut|nop|block|if|then|else|loop|br_if|br_table|br|call(_indirect)?|drop|end|return(_call(_indirect)?)?|local\.(get|set|tee)|global\.(get|set)|i(32|64)\.(store(8|16)|(load(8|16)_[su]))|i64\.(load32_[su]|store32)|[fi](32|64)\.(const|load|store)|f(32|64)\.(abs|add|ceil|copysign|div|eq|floor|[gl][et]|max|min|mul|nearest|neg?|sqrt|sub|trunc)|i(32|64)\.(a[dn]d|c[lt]z|(div|rem)_[su]|eqz?|[gl][te]_[su]|mul|ne|popcnt|rot[lr]|sh(l|r_[su])|sub|x?or)|i64\.extend_[su]_i32|i32\.wrap_i64|i(32|64)\.trunc_f(32|64)_[su]|f(32|64)\.convert_i(32|64)_[su]|f64\.promote_f32|f32\.demote_f64|f32\.reinterpret_i32|i32\.reinterpret_f32|f64\.reinterpret_i64|i64\.reinterpret_f64|select|unreachable|current_memory|memory(\.((atomic\.(notify|wait(32|64)))|grow|size))?|type|\bfunc\b|param|result|local|global|module|start|elem|data|align|offset|import|export|i64\.atomic\.(load32_u|store32|rmw32\.(a[dn]d|sub|x?or|(cmp)?xchg)_u)|i(32|64)\.atomic\.(load((8|16)_u)?|store(8|16)?|rmw(\.(a[dn]d|sub|x?or|(cmp)?xchg)|(8|16)\.(a[dn]d|sub|x?or|(cmp)?xchg)_u))|v128\.(load|store|const|not|andnot|and|or|xor|bitselect)|i(8x16|16x8|32x4|64x2)\.(shl|shr_[su])|i(8x16|16x8)\.(extract_lane_[su]|((add|sub)_saturate_[su])|avgr_u)|(i(8x16|16x8|32x4|64x2)|f(32x4|64x2))\.(splat|replace_lane|neg|add|sub)|i(8x16|16x8|32x4)\.(eq|ne|([lg][te]_[su])|abs|any_true|all_true|bitmask|((min|max)_[su]))|f(32x4|64x2)\.(eq|ne|[lg][te]|abs|sqrt|mul|div|min|max)|[fi](32x4|64x2)\.extract_lane|v8x16\.(shuffle|swizzle)|i16x8\.(load8x8_[su]|narrow_i32x4_[su]|widen_(low|high)_i8x16_[su]|mul)|i32x4\.(load16x4_[su]|widen_(low|high)_i16x8_[su]|mul|trunc_sat_f32x4_[su])|i64x2\.(load32x2_[su]|mul)|(v(8x16|16x8|32x4|64x2)\.load_splat)|i8x16\.narrow_i16x8_[su]|f32x4\.convert_i32x4_[su]|ref\.(func|(is_)?null)|\bextern\b|table(\.(size|get|set|size|grow|fill|init|copy))?/, token: "keyword"},
+    {regex: /\b(funcref|externref|[fi](32|64))\b/, token: "atom"},
     {regex: /\$([a-zA-Z0-9_`\+\-\*\/\\\^~=<>!\?@#$%&|:\.]+)/, token: "variable-2"},
     {regex: /"(?:[^"\\\x00-\x1f\x7f]|\\[nt\\'"]|\\[0-9a-fA-F][0-9a-fA-F])*"/, token: "string"},
     {regex: /\(;.*?/, token: "comment", next: "comment"},
diff -pruN 5.58.2+~cs0.23.101-1/mode/xml/xml.js 5.59.0+~cs0.23.105-1/mode/xml/xml.js
--- 5.58.2+~cs0.23.101-1/mode/xml/xml.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/mode/xml/xml.js	2020-12-20 10:48:25.000000000 +0000
@@ -189,7 +189,7 @@ CodeMirror.defineMode("xml", function(ed
 
   function Context(state, tagName, startOfLine) {
     this.prev = state.context;
-    this.tagName = tagName;
+    this.tagName = tagName || "";
     this.indent = state.indented;
     this.startOfLine = startOfLine;
     if (config.doNotIndent.hasOwnProperty(tagName) || (state.context && state.context.noIndent))
@@ -399,7 +399,7 @@ CodeMirror.defineMode("xml", function(ed
     xmlCurrentContext: function(state) {
       var context = []
       for (var cx = state.context; cx; cx = cx.prev)
-        if (cx.tagName) context.push(cx.tagName)
+        context.push(cx.tagName)
       return context.reverse()
     }
   };
diff -pruN 5.58.2+~cs0.23.101-1/package.json 5.59.0+~cs0.23.105-1/package.json
--- 5.58.2+~cs0.23.101-1/package.json	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/package.json	2020-12-20 10:48:25.000000000 +0000
@@ -1,6 +1,6 @@
 {
   "name": "codemirror",
-  "version": "5.58.2",
+  "version": "5.59.0",
   "main": "lib/codemirror.js",
   "style": "lib/codemirror.css",
   "author": {
diff -pruN 5.58.2+~cs0.23.101-1/src/display/focus.js 5.59.0+~cs0.23.105-1/src/display/focus.js
--- 5.58.2+~cs0.23.101-1/src/display/focus.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/src/display/focus.js	2020-12-20 10:48:25.000000000 +0000
@@ -4,19 +4,22 @@ import { addClass, rmClass } from "../ut
 import { signal } from "../util/event.js"
 
 export function ensureFocus(cm) {
-  if (!cm.state.focused) { cm.display.input.focus(); onFocus(cm) }
+  if (!cm.hasFocus()) {
+    cm.display.input.focus()
+    if (!cm.state.focused) onFocus(cm)
+  }
 }
 
 export function delayBlurEvent(cm) {
   cm.state.delayingBlurEvent = true
   setTimeout(() => { if (cm.state.delayingBlurEvent) {
     cm.state.delayingBlurEvent = false
-    onBlur(cm)
+    if (cm.state.focused) onBlur(cm)
   } }, 100)
 }
 
 export function onFocus(cm, e) {
-  if (cm.state.delayingBlurEvent) cm.state.delayingBlurEvent = false
+  if (cm.state.delayingBlurEvent && !cm.state.draggingText) cm.state.delayingBlurEvent = false
 
   if (cm.options.readOnly == "nocursor") return
   if (!cm.state.focused) {
diff -pruN 5.58.2+~cs0.23.101-1/src/edit/main.js 5.59.0+~cs0.23.105-1/src/edit/main.js
--- 5.58.2+~cs0.23.101-1/src/edit/main.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/src/edit/main.js	2020-12-20 10:48:25.000000000 +0000
@@ -66,4 +66,4 @@ import { addLegacyProps } from "./legacy
 
 addLegacyProps(CodeMirror)
 
-CodeMirror.version = "5.58.2"
+CodeMirror.version = "5.59.0"
diff -pruN 5.58.2+~cs0.23.101-1/src/edit/mouse_events.js 5.59.0+~cs0.23.105-1/src/edit/mouse_events.js
--- 5.58.2+~cs0.23.101-1/src/edit/mouse_events.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/src/edit/mouse_events.js	2020-12-20 10:48:25.000000000 +0000
@@ -149,6 +149,10 @@ function leftButtonStartDrag(cm, event,
   let dragEnd = operation(cm, e => {
     if (webkit) display.scroller.draggable = false
     cm.state.draggingText = false
+    if (cm.state.delayingBlurEvent) {
+      if (cm.hasFocus()) cm.state.delayingBlurEvent = false
+      else delayBlurEvent(cm)
+    }
     off(display.wrapper.ownerDocument, "mouseup", dragEnd)
     off(display.wrapper.ownerDocument, "mousemove", mouseMove)
     off(display.scroller, "dragstart", dragStart)
@@ -172,15 +176,15 @@ function leftButtonStartDrag(cm, event,
   if (webkit) display.scroller.draggable = true
   cm.state.draggingText = dragEnd
   dragEnd.copy = !behavior.moveOnDrag
-  // IE's approach to draggable
-  if (display.scroller.dragDrop) display.scroller.dragDrop()
   on(display.wrapper.ownerDocument, "mouseup", dragEnd)
   on(display.wrapper.ownerDocument, "mousemove", mouseMove)
   on(display.scroller, "dragstart", dragStart)
   on(display.scroller, "drop", dragEnd)
 
-  delayBlurEvent(cm)
+  cm.state.delayingBlurEvent = true
   setTimeout(() => display.input.focus(), 20)
+  // IE's approach to draggable
+  if (display.scroller.dragDrop) display.scroller.dragDrop()
 }
 
 function rangeForUnit(cm, pos, unit) {
@@ -193,6 +197,7 @@ function rangeForUnit(cm, pos, unit) {
 
 // Normal selection, as opposed to text dragging.
 function leftButtonSelect(cm, event, start, behavior) {
+  if (ie) delayBlurEvent(cm)
   let display = cm.display, doc = cm.doc
   e_preventDefault(event)
 
diff -pruN 5.58.2+~cs0.23.101-1/src/model/line_widget.js 5.59.0+~cs0.23.105-1/src/model/line_widget.js
--- 5.58.2+~cs0.23.101-1/src/model/line_widget.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/src/model/line_widget.js	2020-12-20 10:48:25.000000000 +0000
@@ -63,7 +63,7 @@ export function addLineWidget(doc, handl
   changeLine(doc, handle, "widget", line => {
     let widgets = line.widgets || (line.widgets = [])
     if (widget.insertAt == null) widgets.push(widget)
-    else widgets.splice(Math.min(widgets.length - 1, Math.max(0, widget.insertAt)), 0, widget)
+    else widgets.splice(Math.min(widgets.length, Math.max(0, widget.insertAt)), 0, widget)
     widget.line = line
     if (cm && !lineIsHidden(doc, line)) {
       let aboveVisible = heightAtLine(line) < doc.scrollTop
diff -pruN 5.58.2+~cs0.23.101-1/src/util/browser.js 5.59.0+~cs0.23.105-1/src/util/browser.js
--- 5.58.2+~cs0.23.101-1/src/util/browser.js	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/src/util/browser.js	2020-12-20 10:48:25.000000000 +0000
@@ -17,7 +17,7 @@ export let safari = /Apple Computer/.tes
 export let mac_geMountainLion = /Mac OS X 1\d\D([8-9]|\d\d)\D/.test(userAgent)
 export let phantom = /PhantomJS/.test(userAgent)
 
-export let ios = !edge && /AppleWebKit/.test(userAgent) && /Mobile\/\w+/.test(userAgent)
+export let ios = !edge && /AppleWebKit/.test(userAgent) && (/Mobile\/\w+/.test(userAgent) || navigator.maxTouchPoints > 2)
 export let android = /Android/.test(userAgent)
 // This is woefully incomplete. Suggestions for alternative methods welcome.
 export let mobile = ios || android || /webOS|BlackBerry|Opera Mini|Opera Mobi|IEMobile/i.test(userAgent)
diff -pruN 5.58.2+~cs0.23.101-1/theme/solarized.css 5.59.0+~cs0.23.105-1/theme/solarized.css
--- 5.58.2+~cs0.23.101-1/theme/solarized.css	2020-10-26 08:09:11.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/theme/solarized.css	2020-12-20 10:48:25.000000000 +0000
@@ -99,7 +99,7 @@ http://ethanschoonover.com/solarized/img
 
 .cm-s-solarized.cm-s-light div.CodeMirror-selected { background: #eee8d5; }
 .cm-s-solarized.cm-s-light .CodeMirror-line::selection, .cm-s-light .CodeMirror-line > span::selection, .cm-s-light .CodeMirror-line > span > span::selection { background: #eee8d5; }
-.cm-s-solarized.cm-s-light .CodeMirror-line::-moz-selection, .cm-s-ligh .CodeMirror-line > span::-moz-selection, .cm-s-ligh .CodeMirror-line > span > span::-moz-selection { background: #eee8d5; }
+.cm-s-solarized.cm-s-light .CodeMirror-line::-moz-selection, .cm-s-light .CodeMirror-line > span::-moz-selection, .cm-s-light .CodeMirror-line > span > span::-moz-selection { background: #eee8d5; }
 
 /* Editor styling */
 
diff -pruN 5.58.2+~cs0.23.101-1/types-codemirror/addon/hint/show-hint.d.ts 5.59.0+~cs0.23.105-1/types-codemirror/addon/hint/show-hint.d.ts
--- 5.58.2+~cs0.23.101-1/types-codemirror/addon/hint/show-hint.d.ts	2020-09-07 10:37:54.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/types-codemirror/addon/hint/show-hint.d.ts	2020-12-05 09:18:07.000000000 +0000
@@ -55,7 +55,7 @@ declare module 'codemirror' {
 
     interface ShowHintOptions {
         completeSingle?: boolean;
-        hint: HintFunction | AsyncHintFunction;
+        hint?: HintFunction | AsyncHintFunction;
         alignWithWord?: boolean;
         closeCharacters?: RegExp;
         closeOnUnfocus?: boolean;
diff -pruN 5.58.2+~cs0.23.101-1/types-codemirror/addon/mode/simple.d.ts 5.59.0+~cs0.23.105-1/types-codemirror/addon/mode/simple.d.ts
--- 5.58.2+~cs0.23.101-1/types-codemirror/addon/mode/simple.d.ts	1970-01-01 00:00:00.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/types-codemirror/addon/mode/simple.d.ts	2020-12-05 09:18:07.000000000 +0000
@@ -0,0 +1,22 @@
+import * as CodeMirror from "codemirror";
+
+declare module "codemirror" {
+  // Based on https://codemirror.net/demo/simplemode.html
+  interface Rule {
+    regex?: string | RegExp;
+    token?: string | Array<string> | null;
+    sol?: boolean;
+    next?: string;
+    push?: string;
+    pop?: boolean;
+    mode?: any;
+    indent?: boolean;
+    dedent?: boolean;
+    dedentIfLineStart?: boolean;
+  }
+
+  function defineSimpleMode(
+    name: string,
+    mode: { start: Array<Rule>; comment?: Array<Rule>; meta?: any }
+  ): void;
+}
diff -pruN 5.58.2+~cs0.23.101-1/types-codemirror/index.d.ts 5.59.0+~cs0.23.105-1/types-codemirror/index.d.ts
--- 5.58.2+~cs0.23.101-1/types-codemirror/index.d.ts	2020-09-07 10:37:53.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/types-codemirror/index.d.ts	2020-12-05 09:18:07.000000000 +0000
@@ -10,6 +10,7 @@
 //                 kylesferrazza <https://github.com/kylesferrazza>
 //                 fityocsaba96 <https://github.com/fityocsaba96>
 //                 koddsson <https://github.com/koddsson>
+//                 ficristo <https://github.com/ficristo>
 // Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped
 // TypeScript Version: 3.2
 
@@ -113,8 +114,16 @@ declare namespace CodeMirror {
     function off(doc: Doc, eventName: 'cursorActivity', handler: (instance: CodeMirror.Editor) => void): void;
 
     /** Equivalent to the event by the same name as fired on editor instances. */
-    function on(doc: Doc, eventName: 'beforeSelectionChange', handler: (instance: CodeMirror.Editor, obj: EditorSelectionChange) => void ): void;
-    function off(doc: Doc, eventName: 'beforeSelectionChange', handler: (instance: CodeMirror.Editor, obj: EditorSelectionChange) => void ): void;
+    function on(
+        doc: Doc,
+        eventName: 'beforeSelectionChange',
+        handler: (instance: CodeMirror.Editor, obj: EditorSelectionChange) => void,
+    ): void;
+    function off(
+        doc: Doc,
+        eventName: 'beforeSelectionChange',
+        handler: (instance: CodeMirror.Editor, obj: EditorSelectionChange) => void,
+    ): void;
 
     /** Will be fired when the line object is deleted. A line object is associated with the start of the line.
     Mostly useful when you need to find out when your gutter markers on a given line are removed. */
@@ -543,8 +552,14 @@ declare namespace CodeMirror {
 
         /** This event is fired before the selection is moved. Its handler may modify the resulting selection head and anchor.
         Handlers for this event have the same restriction as "beforeChange" handlers they should not do anything to directly update the state of the editor. */
-        on(eventName: 'beforeSelectionChange', handler: (instance: CodeMirror.Editor, obj: EditorSelectionChange) => void ): void;
-        off(eventName: 'beforeSelectionChange', handler: (instance: CodeMirror.Editor, obj: EditorSelectionChange) => void ): void;
+        on(
+            eventName: 'beforeSelectionChange',
+            handler: (instance: CodeMirror.Editor, obj: EditorSelectionChange) => void,
+        ): void;
+        off(
+            eventName: 'beforeSelectionChange',
+            handler: (instance: CodeMirror.Editor, obj: EditorSelectionChange) => void,
+        ): void;
 
         /** Fires whenever the view port of the editor changes (due to scrolling, editing, or any other factor).
         The from and to arguments give the new start and end of the viewport. */
@@ -687,7 +702,12 @@ declare namespace CodeMirror {
 
         /** Replace the part of the document between from and to with the given string.
         from and to must be {line, ch} objects. to can be left off to simply insert the string at position from. */
-        replaceRange(replacement: string | string[], from: CodeMirror.Position, to?: CodeMirror.Position, origin?: string): void;
+        replaceRange(
+            replacement: string | string[],
+            from: CodeMirror.Position,
+            to?: CodeMirror.Position,
+            origin?: string,
+        ): void;
 
         /** Get the content of line n. */
         getLine(n: number): string;
@@ -748,6 +768,11 @@ declare namespace CodeMirror {
         The optional collapse argument can be used to change this -- passing "start" or "end" will collapse the selection to the start or end of the inserted text. */
         replaceSelection(replacement: string, collapse?: string): void;
 
+        /** Replaces the content of the selections with the strings in the array.
+        The length of the given array should be the same as the number of active selections.
+        The collapse argument works the same as in replaceSelection. */
+        replaceSelections(replacements: Array<string>, collapse?: string): void;
+
         /** start is a an optional string indicating which end of the selection to return.
         It may be "from", "to", "head" (the side of the selection that moves when you press shift+arrow),
         or "anchor" (the fixed side of the selection).Omitting the argument is the same as passing "head". A {line, ch} object will be returned. **/
@@ -1240,15 +1265,21 @@ declare namespace CodeMirror {
         /** Determines whether text inserted on the left of the marker will end up inside or outside of it. */
         inclusiveLeft?: boolean;
 
-        /** Like inclusiveLeft , but for the right side. */
+        /** Like inclusiveLeft, but for the right side. */
         inclusiveRight?: boolean;
 
+        /** For atomic ranges, determines whether the cursor is allowed to be placed directly to the left of the range. Has no effect on non-atomic ranges. */
+        selectLeft?: boolean;
+
+        /** Like selectLeft, but for the right side. */
+        selectRight?: boolean;
+
         /** Atomic ranges act as a single unit when cursor movement is concerned — i.e. it is impossible to place the cursor inside of them.
-        In atomic ranges, inclusiveLeft and inclusiveRight have a different meaning — they will prevent the cursor from being placed
-        respectively directly before and directly after the range. */
+        You can control whether the cursor is allowed to be placed directly before or after them using selectLeft or selectRight.
+        If selectLeft (or right) is not provided, then inclusiveLeft (or right) will control this behavior. */
         atomic?: boolean;
 
-        /** Collapsed ranges do not show up in the display.Setting a range to be collapsed will automatically make it atomic. */
+        /** Collapsed ranges do not show up in the display. Setting a range to be collapsed will automatically make it atomic. */
         collapsed?: boolean;
 
         /** When enabled, will cause the mark to clear itself whenever the cursor enters its range.
@@ -1259,8 +1290,8 @@ declare namespace CodeMirror {
         /** Determines whether the mark is automatically cleared when it becomes empty. Default is true. */
         clearWhenEmpty?: boolean;
 
-        /** Use a given node to display this range.Implies both collapsed and atomic.
-        The given DOM node must be an inline element(as opposed to a block element). */
+        /** Use a given node to display this range. Implies both collapsed and atomic.
+        The given DOM node must be an inline element (as opposed to a block element). */
         replacedWith?: HTMLElement;
 
         /** When replacedWith is given, this determines whether the editor will
@@ -1274,7 +1305,7 @@ declare namespace CodeMirror {
         because existing undo events being partially nullified by read - only spans would corrupt the history (in the current implementation). */
         readOnly?: boolean;
 
-        /** When set to true (default is false), adding this marker will create an event in the undo history that can be individually undone(clearing the marker). */
+        /** When set to true (default is false), adding this marker will create an event in the undo history that can be individually undone (clearing the marker). */
         addToHistory?: boolean;
 
         /** Can be used to specify an extra CSS class to be applied to the leftmost span that is part of the marker. */
@@ -1289,6 +1320,9 @@ declare namespace CodeMirror {
         /** When given, will give the nodes created for this span a HTML title attribute with the given value. */
         title?: string;
 
+        /** When given, add the attributes in the given object to the elements created for the marked text. Adding class or style attributes this way is not supported. */
+        attributes?: { [name: string]: string };
+
         /** When the target document is linked to other documents, you can set shared to true to make the marker appear in all documents.
         By default, a marker appears only in its target document. */
         shared?: boolean;
@@ -1677,12 +1711,12 @@ declare namespace CodeMirror {
         delay?: number;
 
         /** callback to modify an annotation before display */
-        formatAnnotation?: (annotation: Annotation) => Annotation
+        formatAnnotation?: (annotation: Annotation) => Annotation;
 
         /** custom linting function provided by the user */
         getAnnotations?: Linter | AsyncLinter;
 
-        /** 
+        /**
          * specifies that lint errors should be displayed in the CodeMirror
          * gutter, note that you must use this in conjunction with [ "CodeMirror-lint-markers" ] as an element in the gutters argument on
          * initialization of the CodeMirror instance. */
@@ -1701,14 +1735,16 @@ declare namespace CodeMirror {
         options?: any;
 
         /** controls display of lint tooltips */
-        tooltips?: boolean | 'gutter'
+        tooltips?: boolean | 'gutter';
     }
 
     /**
      * A function that return errors found during the linting process.
      */
     interface Linter {
-        (content: string, options: LintStateOptions | any, codeMirror: Editor): Annotation[] | PromiseLike<Annotation[]>;
+        (content: string, options: LintStateOptions | any, codeMirror: Editor):
+            | Annotation[]
+            | PromiseLike<Annotation[]>;
     }
 
     /**
diff -pruN 5.58.2+~cs0.23.101-1/types-codemirror/package.json 5.59.0+~cs0.23.105-1/types-codemirror/package.json
--- 5.58.2+~cs0.23.101-1/types-codemirror/package.json	2020-09-07 10:37:53.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/types-codemirror/package.json	2020-12-05 09:18:06.000000000 +0000
@@ -1,6 +1,6 @@
 {
     "name": "@types/codemirror",
-    "version": "0.0.98",
+    "version": "0.0.102",
     "description": "TypeScript definitions for codemirror",
     "license": "MIT",
     "contributors": [
@@ -53,6 +53,11 @@
             "name": "koddsson",
             "url": "https://github.com/koddsson",
             "githubUsername": "koddsson"
+        },
+        {
+            "name": "ficristo",
+            "url": "https://github.com/ficristo",
+            "githubUsername": "ficristo"
         }
     ],
     "main": "",
@@ -66,6 +71,6 @@
     "dependencies": {
         "@types/tern": "*"
     },
-    "typesPublisherContentHash": "8553d41f94a3c1931ad926c6645c32792898677a994498238cbd5f375bc2f152",
-    "typeScriptVersion": "3.2"
+    "typesPublisherContentHash": "1dbfa6fd6889e32f05e71fdb481261c961610e83d4fdd276620978b72e148cfd",
+    "typeScriptVersion": "3.3"
 }
\ No newline at end of file
diff -pruN 5.58.2+~cs0.23.101-1/types-codemirror/README.md 5.59.0+~cs0.23.105-1/types-codemirror/README.md
--- 5.58.2+~cs0.23.101-1/types-codemirror/README.md	2020-09-07 10:37:53.000000000 +0000
+++ 5.59.0+~cs0.23.105-1/types-codemirror/README.md	2020-12-05 09:18:06.000000000 +0000
@@ -8,9 +8,9 @@ This package contains type definitions f
 Files were exported from https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/codemirror.
 
 ### Additional Details
- * Last updated: Mon, 07 Sep 2020 10:37:53 GMT
+ * Last updated: Sat, 05 Dec 2020 09:18:06 GMT
  * Dependencies: [@types/tern](https://npmjs.com/package/@types/tern)
  * Global values: `CodeMirror`
 
 # Credits
-These definitions were written by [mihailik](https://github.com/mihailik), [nrbernard](https://github.com/nrbernard), [Pr1st0n](https://github.com/Pr1st0n), [rileymiller](https://github.com/rileymiller), [toddself](https://github.com/toddself), [ysulyma](https://github.com/ysulyma), [azoson](https://github.com/azoson), [kylesferrazza](https://github.com/kylesferrazza), [fityocsaba96](https://github.com/fityocsaba96), and [koddsson](https://github.com/koddsson).
+These definitions were written by [mihailik](https://github.com/mihailik), [nrbernard](https://github.com/nrbernard), [Pr1st0n](https://github.com/Pr1st0n), [rileymiller](https://github.com/rileymiller), [toddself](https://github.com/toddself), [ysulyma](https://github.com/ysulyma), [azoson](https://github.com/azoson), [kylesferrazza](https://github.com/kylesferrazza), [fityocsaba96](https://github.com/fityocsaba96), [koddsson](https://github.com/koddsson), and [ficristo](https://github.com/ficristo).
